dart_library.library('lib_animation', null, /* Imports */[
  'dart_sdk',
  'pub_vector_math'
], (function load__lib_animation(exports, dart_sdk, pub_vector_math) {
  'use strict';
  const core = dart_sdk.core;
  const _interceptors = dart_sdk._interceptors;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  let vector_math = dart_library.defer(pub_vector_math, "vector_math", function(mod, lib) {
    pub_vector_math = mod;
    vector_math = lib;
  });
  const lib__src__animation__lib = Object.create(null);
  let ListOfMatrix4 = () => (ListOfMatrix4 = dart.constFn(core.List$(vector_math.Matrix4)))();
  let ListOfBone = () => (ListOfBone = dart.constFn(core.List$(lib__src__animation__lib.Bone)))();
  let JSArrayOfdouble = () => (JSArrayOfdouble = dart.constFn(_interceptors.JSArray$(core.double)))();
  let JSArrayOfVector3 = () => (JSArrayOfVector3 = dart.constFn(_interceptors.JSArray$(vector_math.Vector3)))();
  let JSArrayOfQuaternion = () => (JSArrayOfQuaternion = dart.constFn(_interceptors.JSArray$(vector_math.Quaternion)))();
  let JSArrayOfString = () => (JSArrayOfString = dart.constFn(_interceptors.JSArray$(core.String)))();
  let ListOfdouble = () => (ListOfdouble = dart.constFn(core.List$(core.double)))();
  let ListOfVector3 = () => (ListOfVector3 = dart.constFn(core.List$(vector_math.Vector3)))();
  let ListOfQuaternion = () => (ListOfQuaternion = dart.constFn(core.List$(vector_math.Quaternion)))();
  let ListOfBoneAnimation = () => (ListOfBoneAnimation = dart.constFn(core.List$(lib__src__animation__lib.BoneAnimation)))();
  let ListOfBoneTovoid = () => (ListOfBoneTovoid = dart.constFn(dart.definiteFunctionType(dart.void, [ListOfBone()])))();
  let ListOfBoneAndMatrix4AndSkeletalAnimation__Tovoid = () => (ListOfBoneAndMatrix4AndSkeletalAnimation__Tovoid = dart.constFn(dart.definiteFunctionType(dart.void, [ListOfBone(), vector_math.Matrix4, lib__src__animation__lib.SkeletalAnimation, lib__src__animation__lib.AnimatedSkeleton, core.double])))();
  let ListOfBoneToListOfVector3 = () => (ListOfBoneToListOfVector3 = dart.constFn(dart.definiteFunctionType(ListOfVector3(), [ListOfBone()])))();
  let ListOfBoneAndAnimatedSkeleton__ToListOfVector3 = () => (ListOfBoneAndAnimatedSkeleton__ToListOfVector3 = dart.constFn(dart.definiteFunctionType(ListOfVector3(), [ListOfBone(), lib__src__animation__lib.AnimatedSkeleton], {scale: core.double})))();
  lib__src__animation__lib.Bone = class Bone extends core.Object {
    new(boneName, boneIndex, parentNum, localTransform, offsetTransform) {
      this.boneName = boneName;
      this.boneIndex = boneIndex;
      this.parentNum = parentNum;
      this.localTransform = localTransform;
      this.offsetTransform = offsetTransform;
      dart.assert(dart.notNull(this.boneIndex) > dart.notNull(this.parentNum));
    }
    toString() {
      return dart.str`BONE[${this.boneIndex}] (${this.parentNum}) ${this.boneName}\n` + dart.str`trans:\n${this.localTransform}` + dart.str`offset:\n${this.offsetTransform}`;
    }
  };
  dart.setSignature(lib__src__animation__lib.Bone, {
    fields: () => ({
      boneName: core.String,
      localTransform: vector_math.Matrix4,
      offsetTransform: vector_math.Matrix4,
      boneIndex: core.int,
      parentNum: core.int
    })
  });
  lib__src__animation__lib.AnimatedSkeleton = class AnimatedSkeleton extends core.Object {
    new(length) {
      this.globalTransforms = ListOfMatrix4().new(length);
      this.skinningTransforms = ListOfMatrix4().new(length);
      for (let i = 0; i < dart.notNull(length); i++) {
        this.globalTransforms[dartx._set](i, new vector_math.Matrix4.zero());
        this.skinningTransforms[dartx._set](i, new vector_math.Matrix4.zero());
      }
    }
  };
  dart.setSignature(lib__src__animation__lib.AnimatedSkeleton, {
    fields: () => ({
      globalTransforms: ListOfMatrix4(),
      skinningTransforms: ListOfMatrix4()
    })
  });
  lib__src__animation__lib.RecomputeLocalOffsets = function(skeleton) {
    core.print("recomputing local transform");
    let toRoot = ListOfMatrix4().new(skeleton[dartx.length]);
    for (let i = 0; i < dart.notNull(skeleton[dartx.length]); i++) {
      let bone = skeleton[dartx._get](i);
      if (dart.notNull(bone.parentNum) < 0) {
        toRoot[dartx._set](i, vector_math.Matrix4._check(vector_math.Matrix4.identity()['*'](bone.localTransform)));
      } else {
        toRoot[dartx._set](i, vector_math.Matrix4._check(toRoot[dartx._get](bone.parentNum)['*'](bone.localTransform)));
      }
      bone.offsetTransform.copyInverse(toRoot[dartx._get](i));
    }
  };
  dart.fn(lib__src__animation__lib.RecomputeLocalOffsets, ListOfBoneTovoid());
  lib__src__animation__lib.UpdateAnimatedSkeleton = function(skeleton, globalOffsetTransform, animation, posedSkeleton, time) {
    let tmp = new vector_math.Matrix4.zero();
    for (let i = 0; i < dart.notNull(skeleton[dartx.length]); i++) {
      let bone = skeleton[dartx._get](i);
      let t = posedSkeleton.globalTransforms[dartx._get](i);
      if (dart.notNull(bone.parentNum) < 0) {
        t.setIdentity();
      } else {
        t.setFrom(posedSkeleton.globalTransforms[dartx._get](bone.parentNum));
      }
      let a = animation.animList[dartx._get](i);
      if (a != null) {
        a.setBoneMatrixAtTick(time, tmp);
        t.multiply(tmp);
      } else {
        t.multiply(bone.localTransform);
      }
    }
    for (let i = 0; i < dart.notNull(skeleton[dartx.length]); i++) {
      let t = posedSkeleton.skinningTransforms[dartx._get](i);
      t.setFrom(globalOffsetTransform);
      t.multiply(posedSkeleton.globalTransforms[dartx._get](i));
      t.multiply(skeleton[dartx._get](i).offsetTransform);
    }
  };
  dart.lazyFn(lib__src__animation__lib.UpdateAnimatedSkeleton, () => ListOfBoneAndMatrix4AndSkeletalAnimation__Tovoid());
  const _positionTimes = Symbol('_positionTimes');
  const _positionValues = Symbol('_positionValues');
  const _rotationTimes = Symbol('_rotationTimes');
  const _rotationValues = Symbol('_rotationValues');
  const _scaleTimes = Symbol('_scaleTimes');
  const _scaleValues = Symbol('_scaleValues');
  lib__src__animation__lib.BoneAnimation = class BoneAnimation extends core.Object {
    new(bone, positionTimes, positionValues, rotationTimes, rotationValues, scaleTimes, scaleValues) {
      this.bone = bone;
      this[_positionTimes] = positionTimes;
      this[_positionValues] = positionValues;
      this[_rotationTimes] = rotationTimes;
      this[_rotationValues] = rotationValues;
      this[_scaleTimes] = scaleTimes;
      this[_scaleValues] = scaleValues;
      if (this[_positionTimes] == null || this[_positionTimes][dartx.length] == 0) {
        this[_positionTimes] = JSArrayOfdouble().of([0.0]);
        this[_positionValues] = JSArrayOfVector3().of([vector_math.Vector3.new(0.0, 0.0, 0.0)]);
      }
      if (this[_rotationTimes] == null || this[_rotationTimes][dartx.length] == 0) {
        this[_rotationTimes] = JSArrayOfdouble().of([0.0]);
        this[_rotationValues] = JSArrayOfQuaternion().of([vector_math.Quaternion.new(0.0, 0.0, 0.0, 1.0)]);
      }
      if (this[_scaleTimes] == null || this[_scaleTimes][dartx.length] == 0) {
        this[_scaleTimes] = JSArrayOfdouble().of([0.0]);
        this[_scaleValues] = JSArrayOfVector3().of([vector_math.Vector3.new(1.0, 1.0, 1.0)]);
      }
      dart.assert(dart.notNull(this[_rotationTimes][dartx.length]) > 0);
      dart.assert(dart.notNull(this[_positionTimes][dartx.length]) > 0);
      dart.assert(dart.notNull(this[_scaleTimes][dartx.length]) > 0);
      dart.assert(this[_rotationTimes][dartx.length] == this[_rotationValues][dartx.length]);
      dart.assert(this[_positionTimes][dartx.length] == this[_positionValues][dartx.length]);
      dart.assert(this[_scaleTimes][dartx.length] == this[_scaleValues][dartx.length]);
    }
    static _findTime(timeList, t) {
      for (let i = 0; i < dart.notNull(timeList[dartx.length]) - 1; i++) {
        if (dart.notNull(t) < dart.notNull(timeList[dartx._get](i + 1))) {
          return i;
        }
      }
      return 0;
    }
    setBoneMatrixAtTick(tick, boneMatrix) {
      let scaleIndex = lib__src__animation__lib.BoneAnimation._findTime(this[_scaleTimes], tick);
      dart.assert(dart.notNull(scaleIndex) >= 0);
      let positionIndex = lib__src__animation__lib.BoneAnimation._findTime(this[_positionTimes], tick);
      dart.assert(dart.notNull(positionIndex) >= 0);
      let rotationIndex = lib__src__animation__lib.BoneAnimation._findTime(this[_rotationTimes], tick);
      dart.assert(dart.notNull(rotationIndex) >= 0);
      let s = this[_scaleValues][dartx._get](scaleIndex);
      let t = this[_positionValues][dartx._get](positionIndex);
      let r = this[_rotationValues][dartx._get](rotationIndex);
      boneMatrix.setFromTranslationRotationScale(t, r, s);
    }
    toString() {
      let s = JSArrayOfString().of([]);
      s[dartx.add](dart.str`${this.bone.boneName}`);
      s[dartx.add](dart.str`${this[_positionTimes][dartx.length]}: ${this[_positionValues]}`);
      s[dartx.add](dart.str`${this[_rotationTimes][dartx.length]}: ${this[_rotationValues]}`);
      s[dartx.add](dart.str`${this[_scaleTimes][dartx.length]}: ${this[_scaleValues]}`);
      return s[dartx.join]("\n");
    }
  };
  dart.setSignature(lib__src__animation__lib.BoneAnimation, {
    fields: () => ({
      bone: lib__src__animation__lib.Bone,
      [_positionTimes]: ListOfdouble(),
      [_positionValues]: ListOfVector3(),
      [_rotationTimes]: ListOfdouble(),
      [_rotationValues]: ListOfQuaternion(),
      [_scaleTimes]: ListOfdouble(),
      [_scaleValues]: ListOfVector3()
    }),
    methods: () => ({setBoneMatrixAtTick: dart.definiteFunctionType(dart.void, [core.double, vector_math.Matrix4])}),
    statics: () => ({_findTime: dart.definiteFunctionType(core.int, [ListOfdouble(), core.double])}),
    names: ['_findTime']
  });
  lib__src__animation__lib.SkeletalAnimation = class SkeletalAnimation extends core.Object {
    new(name, duration, length) {
      this.name = name;
      this.duration = duration;
      this.animList = ListOfBoneAnimation().new(length);
    }
    InsertBone(ba) {
      dart.assert(this.animList[dartx._get](ba.bone.boneIndex) == null);
      this.animList[dartx._set](ba.bone.boneIndex, ba);
    }
  };
  dart.setSignature(lib__src__animation__lib.SkeletalAnimation, {
    fields: () => ({
      name: core.String,
      animList: ListOfBoneAnimation(),
      duration: core.double
    }),
    methods: () => ({InsertBone: dart.definiteFunctionType(dart.void, [lib__src__animation__lib.BoneAnimation])})
  });
  lib__src__animation__lib.BonePosFromSkeleton = function(bones) {
    let out = JSArrayOfVector3().of([]);
    for (let i = 1; i < dart.notNull(bones[dartx.length]); ++i) {
      let a = bones[dartx._get](i);
      let b = bones[dartx._get](a.parentNum);
      out[dartx.add](a.localTransform.getTranslation());
      out[dartx.add](b.localTransform.getTranslation());
    }
    core.print(dart.str`skeleton bone ${out[dartx.length]}`);
    return out;
  };
  dart.fn(lib__src__animation__lib.BonePosFromSkeleton, ListOfBoneToListOfVector3());
  lib__src__animation__lib.BonePosFromAnimatedSkeleton = function(bones, posed, opts) {
    let scale = opts && 'scale' in opts ? opts.scale : 1.0;
    let out = JSArrayOfVector3().of([]);
    for (let i = 0; i < dart.notNull(bones[dartx.length]); ++i) {
      let parent = bones[dartx._get](i).parentNum;
      if (parent == -1) continue;
      out[dartx.add](posed.globalTransforms[dartx._get](i).getTranslation()['*'](scale));
      out[dartx.add](posed.globalTransforms[dartx._get](parent).getTranslation()['*'](scale));
    }
    return out;
  };
  dart.fn(lib__src__animation__lib.BonePosFromAnimatedSkeleton, ListOfBoneAndAnimatedSkeleton__ToListOfVector3());
  dart.trackLibraries("lib_animation", {"lib/src/animation/lib.dart": lib__src__animation__lib}, null);
  // Exports:
  exports.lib__src__animation__lib = lib__src__animation__lib;
}));
