dart_library.library('lib_chronosutil', null, /* Imports */[
  'dart_sdk'
], (function load__lib_chronosutil(exports, dart_sdk) {
  'use strict';
  const core = dart_sdk.core;
  const html = dart_sdk.html;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const lib__chronosutil = Object.create(null);
  lib__chronosutil._numBars = 90;
  lib__chronosutil._graphHeight = 30;
  lib__chronosutil._maxFps = 90;
  const _root = Symbol('_root');
  const _text = Symbol('_text');
  const _extra = Symbol('_extra');
  const _graph = Symbol('_graph');
  const _MakeText = Symbol('_MakeText');
  const _MakeGraph = Symbol('_MakeGraph');
  lib__chronosutil.Stats = class Stats extends core.Object {
    new(root, fg, bg) {
      this[_root] = null;
      this[_text] = null;
      this[_extra] = null;
      this[_graph] = null;
      if (root == null) dart.throw("no element provided");
      this[_root] = root;
      this[_root].style[dartx.color] = fg;
      this[_root].style[dartx.fontFamily] = "Helvetica,Arial,sans-serif";
      this[_root].style[dartx.fontSize] = "9px";
      this[_root].style[dartx.lineHeight] = "15px";
      this[_root].style[dartx.padding] = "0 0 3px 3px";
      this[_root].style[dartx.textAlign] = "left";
      this[_root].style[dartx.background] = bg;
      this[_text] = this[_MakeText]("@@@@");
      this[_root][dartx.append](this[_text]);
      this[_graph] = this[_MakeGraph](fg, bg, lib__chronosutil._numBars, lib__chronosutil._graphHeight);
      this[_root][dartx.append](this[_graph]);
      this[_extra] = html.Element.div();
      this[_root][dartx.append](this[_extra]);
    }
    [_MakeText](initial) {
      let text = html.Element.div();
      text.style[dartx.fontWeight] = "bold";
      text[dartx.text] = initial;
      return text;
    }
    [_MakeGraph](fg, bg, bars, height) {
      let graph = html.Element.div();
      graph.style[dartx.width] = dart.str`${bars}px`;
      graph.style[dartx.height] = dart.str`${height}px`;
      graph.style[dartx.color] = fg;
      graph.style[dartx.background] = fg;
      for (let i = 0; i < dart.notNull(bars); i++) {
        let e = html.Element.span();
        e.style[dartx.width] = "1px";
        e.style[dartx.height] = dart.str`${height}px`;
        e.style[dartx.float] = "left";
        e.style[dartx.opacity] = "0.9";
        e.style[dartx.background] = bg;
        graph[dartx.append](e);
      }
      return graph;
    }
    ChangeExtra(s) {
      this[_extra][dartx.innerHtml] = s;
    }
    AddRawValue(v) {
      if (dart.notNull(v) < 0) v = 0;
      if (dart.notNull(v) > lib__chronosutil._graphHeight) v = lib__chronosutil._graphHeight;
      let e = html.Element._check(this[_graph].firstChild);
      e.style[dartx.height] = dart.str`${v}px`;
      this[_graph][dartx.append](e);
    }
  };
  dart.setSignature(lib__chronosutil.Stats, {
    fields: () => ({
      [_root]: html.Element,
      [_text]: html.Element,
      [_extra]: html.Element,
      [_graph]: html.Element
    }),
    methods: () => ({
      [_MakeText]: dart.definiteFunctionType(html.Element, [core.String]),
      [_MakeGraph]: dart.definiteFunctionType(html.Element, [core.String, core.String, core.int, core.int]),
      ChangeExtra: dart.definiteFunctionType(dart.void, [core.String]),
      AddRawValue: dart.definiteFunctionType(dart.void, [core.int])
    })
  });
  lib__chronosutil._SAMPLE_RATE_MS = 1000.0;
  const _frames = Symbol('_frames');
  const _lastSample = Symbol('_lastSample');
  lib__chronosutil.StatsFps = class StatsFps extends lib__chronosutil.Stats {
    new(root, fg, bg) {
      this[_frames] = 0;
      this[_lastSample] = 0.0;
      super.new(root, fg, bg);
    }
    UpdateFrameCount(now, extra) {
      if (extra === void 0) extra = "";
      this[_frames] = dart.notNull(this[_frames]) + 1;
      if (dart.notNull(now) - dart.notNull(this[_lastSample]) < lib__chronosutil._SAMPLE_RATE_MS) return;
      let fps = dart.notNull(this[_frames]) * 1000.0 / lib__chronosutil._SAMPLE_RATE_MS;
      this[_frames] = 0;
      this[_lastSample] = now;
      this[_text][dartx.text] = dart.notNull(fps[dartx.toStringAsFixed](2)) + " fps";
      this[_extra][dartx.innerHtml] = extra;
      this.AddRawValue((lib__chronosutil._graphHeight * dart.notNull(fps[dartx.ceil]()) / lib__chronosutil._maxFps)[dartx.truncate]());
    }
  };
  dart.setSignature(lib__chronosutil.StatsFps, {
    fields: () => ({
      [_frames]: core.int,
      [_lastSample]: core.double
    }),
    methods: () => ({UpdateFrameCount: dart.definiteFunctionType(dart.void, [core.double], [core.String])})
  });
  dart.trackLibraries("lib_chronosutil", {"lib/chronosutil.dart": lib__chronosutil}, null);
  // Exports:
  exports.lib__chronosutil = lib__chronosutil;
}));
