dart_library.library('lib_shader', null, /* Imports */[
  'dart_sdk',
  'lib_base'
], (function load__lib_shader(exports, dart_sdk, lib_base) {
  'use strict';
  const core = dart_sdk.core;
  const _interceptors = dart_sdk._interceptors;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  let lib__src__base__lib = dart_library.defer(lib_base, "lib__src__base__lib", function(mod, lib) {
    lib_base = mod;
    lib__src__base__lib = lib;
  });
  const lib__src__shader__lib = Object.create(null);
  let JSArrayOfString = () => (JSArrayOfString = dart.constFn(_interceptors.JSArray$(core.String)))();
  let JSArrayOfShaderObject = () => (JSArrayOfShaderObject = dart.constFn(_interceptors.JSArray$(lib__src__base__lib.ShaderObject)))();
  let ListOfShaderObject = () => (ListOfShaderObject = dart.constFn(core.List$(lib__src__base__lib.ShaderObject)))();
  let VoidToListOfShaderObject = () => (VoidToListOfShaderObject = dart.constFn(dart.definiteFunctionType(ListOfShaderObject(), [])))();
  let boolToListOfShaderObject = () => (boolToListOfShaderObject = dart.constFn(dart.definiteFunctionType(ListOfShaderObject(), [core.bool])))();
  lib__src__shader__lib.StdVertexBody = dart.str`gl_Position = ${lib__src__base__lib.uPerspectiveViewMatrix} * ${lib__src__base__lib.uModelMatrix} * vec4(${lib__src__base__lib.aVertexPosition}, 1.0);`;
  lib__src__shader__lib.StdVertexTextureForward = dart.str`${lib__src__base__lib.vTextureCoordinates} = ${lib__src__base__lib.aTextureCoordinates};`;
  lib__src__shader__lib.NullVertexBody = dart.str`gl_Position = vec4(${lib__src__base__lib.aVertexPosition}, 1.0);`;
  lib__src__shader__lib.StdLibShader = dart.str`// ============================================================\n// MISC\n// ============================================================\n\nvec3 ColorFromPosition(vec3 pos) {\n    return vec3( sin(pos.x) / 2.0 + 0.5,\n                 cos(pos.y) / 2.0 + 0.5,\n                 sin(pos.z) / 2.0 + 0.5);\n}\n\n// wandalen\n// http://stackoverflow.com/questions/9446888/best-way-to-detect-nans-in-opengl-shaders\n// important: some nVidias failed to cope with version below.\n// Probably wrong optimization.\n// return ( val <= 0.0 || 0.0 <= val ) ? false : true;\nbool isnan( float val ) {\n    return ( val < 0.0 || 0.0 < val || val == 0.0 ) ? false : true;\n}\n\n\nvec3 RangeToGray(float f, float a, float b) {\n    if (f > a) return vec3(1.0);\n    if (f < b) return vec3(0.0);\n    return vec3 ((f - b) / (a-b));\n}\n\nfloat useValueButReturnZero(float x) {\n    return (x + 1.0) * (x + 1.0) - x * x - 2.0 * x - 1.0;\n}\n\n// ============================================================\n// LIGHT\n// ============================================================\n\nfloat GetDiffuse(vec3 lightDir, vec3 normal) {\n    return max(dot(normal, lightDir), 0.0);\n}\n\nfloat GetSpecular(vec3 lightDir, vec3 viewDir, vec3 normal, float glossiness) {\n    vec3 angleW = normalize(viewDir + lightDir);\n    float specComp = max(0., dot(normal, angleW));\n    return pow(specComp, max(1.0, glossiness));\n}\n\nstruct ColorComponents {\n   vec3 diffuse;\n   vec3 specular;\n};\n\n// ============================================================\n// Spot Light\n// ============================================================\n\nstruct SpotLightInfo {\n    vec3 pos;      // for spot and point\n    vec3 dir;      // for spot and dir light\n    vec3 diffuseColor;\n    vec3 specularColor;\n    float range;        // for spot and point\n    float spotCutoff;   // for spot\n    float spotFocus;    // for spot\n    float glossiness;   // Oddball: this comes from the material\n};\n\nSpotLightInfo UnpackSpotLightInfo(mat4 m) {\n    SpotLightInfo info;\n    info.pos = m[0].xyz;\n    info.dir = normalize(m[1].xyz);\n    info.diffuseColor = m[2].xyz;\n    info.specularColor = m[3].xyz;\n    info.glossiness = m[0].a;\n    info.range = m[1].a;\n    info.spotCutoff = m[2].a;\n    info.spotFocus = m[3].a;\n    return info;\n}\n\nColorComponents SpotLightGetDiffuseAndSpecular(SpotLightInfo light,\n                                               vec3 vertexPos,\n                                               vec3 vertexNormal,\n                                               vec3 eyePos,\n                                               float uShininess) {\n    vec3 toSpot = light.pos - vertexPos;\n    vec3 spotDir = normalize(toSpot);\n    vec3 lightDirNorm = -normalize(light.dir);\n    float cosAngle = max(0., dot(lightDirNorm, spotDir));\n\t  if (cosAngle < light.spotCutoff) {\n        return ColorComponents(vec3(0.0), vec3(0.0));\n    }\n\n    cosAngle = max(0.0, pow(cosAngle, light.spotFocus));\n\t  float attenuation = max(0.0, 1.0 - length(toSpot) / light.range) * cosAngle;\n\t  vec3 viewDirNorm = normalize(eyePos - vertexPos);\n\t  return ColorComponents(\n\t           attenuation *\n             GetDiffuse(lightDirNorm, vertexNormal) *\n             light.diffuseColor,\n             attenuation *\n             GetSpecular(lightDirNorm, viewDirNorm, vertexNormal, uShininess) *\n             light.specularColor);\n}\n\n// ============================================================\n// Point Light\n// ============================================================\n\nstruct PointLightInfo {\n    vec3 pos;\n    vec3 diffuseColor;\n    vec3 specularColor;\n    float range;\n    float glossiness;\n};\n\nPointLightInfo UnpackPointLightInfo(mat4 m) {\n    PointLightInfo info;\n    info.pos = m[0].xyz;\n    info.diffuseColor = m[2].xyz;\n    info.specularColor = m[3].xyz;\n    info.range = m[1].a;\n    info.glossiness = m[0].a;\n    return info;\n}\n\nColorComponents PointLightGetDiffuseAndSpecular(PointLightInfo info,\n                                     vec3 vertexPos,\n                                     vec3 vertexNormal,\n                                     vec3 eyePos,\n                                     float uShininess) {\n    vec3 lightDir = info.pos - vertexPos;\n    float attenuation = max(0.0, 1.0 - length(lightDir) / info.range);\n    vec3 lightDirNorm = normalize(lightDir);\n    vec3 viewDirNorm = normalize(eyePos - vertexPos);\n    return ColorComponents(\n              attenuation *\n              GetDiffuse(lightDirNorm, vertexNormal) *\n              info.diffuseColor,\n               attenuation *\n               GetSpecular(lightDirNorm, viewDirNorm, vertexNormal, uShininess) *\n               info.specularColor);\n}\n\n// ============================================================\n// Directional Light\n// ============================================================\n\nstruct DirectionalLightInfo {\n    vec3 dir;      // for spot and dir light\n    vec3 diffuseColor;\n    vec3 specularColor;\n    float glossiness;   // Oddball: this comes from the material\n};\n\nDirectionalLightInfo UnpackDirectionalLightInfo(mat4 m) {\n    DirectionalLightInfo info;\n    info.dir = normalize(m[1].xyz);\n    info.diffuseColor = m[2].xyz;\n    info.specularColor = m[3].xyz;\n    info.glossiness = m[0].a;\n    return info;\n}\n\nColorComponents DirectionalLightGetDiffuseAndSpecular(DirectionalLightInfo info,\n                                                      vec3 vertexPos,\n                                                      vec3 vertexNormal,\n                                                      vec3 eyePos,\n                                                      float uShininess) {\n    vec3 viewDirNorm = normalize(eyePos - vertexPos);\n    return ColorComponents(\n              GetDiffuse(-info.dir, vertexNormal) *\n              info.diffuseColor,\n              GetSpecular(-info.dir, viewDirNorm, vertexNormal, uShininess) *\n              info.specularColor);\n}\n\n// ============================================================\n// Combined Light\n// ============================================================\nColorComponents CombinedLight(vec3 vVertexPosition,\n                   vec3 vNormal,\n                   vec3 uEyePosition,\n                   const mat4 uLightDescs[${lib__src__base__lib.kMaxLights}],\n                   const float uLightTypes[${lib__src__base__lib.kMaxLights}],\n                   float uShininess) {\n    ColorComponents acc = ColorComponents(vec3(0.0), vec3(0.0));\n\n    for (int i = 0; i < ${lib__src__base__lib.kMaxLights}; ++i) {\n        ColorComponents curr;\n        float type = ${lib__src__base__lib.uLightTypes}[i];\n        if (type == ${lib__src__base__lib.lightTypeSpotFloat}) {\n            SpotLightInfo info = UnpackSpotLightInfo(uLightDescs[i]);\n            curr = SpotLightGetDiffuseAndSpecular(info,\n                                           vVertexPosition,\n                                           vNormal,\n                                           uEyePosition,\n                                           uShininess);\n        } else if (type == ${lib__src__base__lib.lightTypePointFloat}) {\n            PointLightInfo info = UnpackPointLightInfo(uLightDescs[i]);\n            curr = PointLightGetDiffuseAndSpecular(info,\n                                            vVertexPosition,\n                                            vNormal,\n                                            uEyePosition,\n                                            uShininess);\n        } else if (type == ${lib__src__base__lib.lightTypeDirectionalFloat}) {\n            DirectionalLightInfo info = UnpackDirectionalLightInfo(uLightDescs[i]);\n            curr = DirectionalLightGetDiffuseAndSpecular(info,\n                                                  vVertexPosition,\n                                                  vNormal,\n                                                  uEyePosition,\n                                                  uShininess);\n        } else {\n            continue;\n        }\n        acc.diffuse = acc.diffuse + curr.diffuse;\n        acc.specular = acc.specular + curr.specular;\n    }\n    return acc;\n}\n\n// ============================================================\n// SHADOW\n// ============================================================\n// r,g,b,a  are in the range of [0, 254]\n// float = r / 255^1 + g / 255^2 + b / 255^3 + a / 255^4\n// float is assumed to be in [0, 1]\n// Not that the conversion from bytes to floats introduces a 1/255 factor\n// Inspired by http://spidergl.org/example.php?id=6\n\n// 256.0 does not work quite as well.\nconst float _b = 255.0;\nconst vec4 _shift = vec4(1.0, _b, _b * _b, _b * _b * _b);\nconst vec4 _shiftInv = vec4(1.0, 1.0 / _b, 1.0 / (_b * _b), 1.0 / (_b * _b * _b));\n\nvec4 packDepth(float depth) {\n\t  vec4 res = fract(depth * _shift);\n    // the next three correction terms can probably be omitted if we\n    // know for sure that we are dealing with 8 bits per color component\n    res.r -= res.g / _b;\n    res.g -= res.b / _b;\n    res.b -= res.a / _b;\n\t  return res;\n}\n\nfloat unpackDepth(vec4 rgba_depth) {\n\t  return dot(rgba_depth, _shiftInv);\n}\n\nfloat computeShadow(vec4 positionFromLight, sampler2D shadowMap,\n                    float darkness, float bias) {\n\t\tvec3 depth = positionFromLight.xyz / positionFromLight.w;\n\t\tdepth = 0.5 * depth + vec3(0.5);\n\t\tvec2 uv = depth.xy;\n\n\t\tif (uv.x < 0.0 || uv.x > 1.0 || uv.y < 0.0 || uv.y > 1.0) {\n\t\t\t// no shadow\n\t\t\treturn 1.0;\n\t\t}\n\n\t\tfloat shadow = unpackDepth(texture2D(shadowMap, uv));\n\n\n\t\tif (depth.z > shadow + bias) {\n\t\t\treturn darkness;\n\t\t}\n\t\treturn 1.0;\n}\n\n`;
  lib__src__shader__lib.StdLibShaderDerivative = "\n#extension GL_OES_standard_derivatives : enable\n\nvec2 dHdxy_fwd(vec2 uv, float scale, sampler2D map) {\n    vec2 dSTdx = dFdx( uv );\n    vec2 dSTdy = dFdy( uv );\n\n    float Hll = scale * texture2D(map, uv ).x;\n    float dBx = scale * texture2D(map, uv + dSTdx ).x - Hll;\n    float dBy = scale * texture2D(map, uv + dSTdy ).x - Hll;\n\n    return vec2( dBx, dBy );\n}\n\nvec3 perturbNormalArb(vec3 surf_pos, vec3 surf_norm, vec2 dHdxy) {\n    surf_norm = normalize  (surf_norm);\n    vec3 vSigmaX = dFdx( surf_pos );\n    vec3 vSigmaY = dFdy( surf_pos );\n    vec3 vN = surf_norm;            // normalized\n\n    vec3 R1 = cross( vSigmaY, vN );\n    vec3 R2 = cross( vN, vSigmaX );\n\n    float fDet = dot( vSigmaX, R1 );\n\n    vec3 vGrad = sign( fDet ) * ( dHdxy.x * R1 + dHdxy.y * R2 );\n    return normalize( abs( fDet ) * surf_norm - vGrad );\n}\n";
  lib__src__shader__lib.createTexturedShader = function() {
    return JSArrayOfShaderObject().of([(() => {
        let _ = new lib__src__base__lib.ShaderObject("Textured");
        _.AddAttributeVar(lib__src__base__lib.aVertexPosition);
        _.AddUniformVar(lib__src__base__lib.uPerspectiveViewMatrix);
        _.AddUniformVar(lib__src__base__lib.uModelMatrix);
        _.AddAttributeVar(lib__src__base__lib.aTextureCoordinates);
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.SetBodyWithMain(JSArrayOfString().of([lib__src__shader__lib.StdVertexBody, lib__src__shader__lib.StdVertexTextureForward]));
        return _;
      })(), (() => {
        let _ = new lib__src__base__lib.ShaderObject("TexturedF");
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.AddUniformVar(lib__src__base__lib.uColor);
        _.AddUniformVar(lib__src__base__lib.uTexture);
        _.SetBodyWithMain(JSArrayOfString().of([dart.str`gl_FragColor = texture2D(${lib__src__base__lib.uTexture}, ${lib__src__base__lib.vTextureCoordinates}) + vec4( ${lib__src__base__lib.uColor}, 0.0 );`]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createTexturedShader, VoidToListOfShaderObject());
  lib__src__shader__lib.createSolidColorShader = function() {
    return JSArrayOfShaderObject().of([(() => {
        let _ = new lib__src__base__lib.ShaderObject("SolidColor");
        _.AddAttributeVar(lib__src__base__lib.aVertexPosition);
        _.AddUniformVar(lib__src__base__lib.uPerspectiveViewMatrix);
        _.AddUniformVar(lib__src__base__lib.uModelMatrix);
        _.SetBodyWithMain(JSArrayOfString().of([lib__src__shader__lib.StdVertexBody]));
        return _;
      })(), (() => {
        let _ = new lib__src__base__lib.ShaderObject("SolidColorF");
        _.AddUniformVar(lib__src__base__lib.uColor);
        _.SetBodyWithMain(JSArrayOfString().of([dart.str`gl_FragColor = vec4( ${lib__src__base__lib.uColor}, 1.0 );`]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createSolidColorShader, VoidToListOfShaderObject());
  lib__src__shader__lib.createCubeMapShader = function() {
    return JSArrayOfShaderObject().of([(() => {
        let _ = new lib__src__base__lib.ShaderObject("CubeMap");
        _.AddAttributeVar(lib__src__base__lib.aVertexPosition);
        _.AddVaryingVar(lib__src__base__lib.vVertexPosition);
        _.AddUniformVar(lib__src__base__lib.uPerspectiveViewMatrix);
        _.AddUniformVar(lib__src__base__lib.uModelMatrix);
        _.SetBodyWithMain(JSArrayOfString().of([lib__src__shader__lib.StdVertexBody, dart.str`${lib__src__base__lib.vVertexPosition} = normalize(${lib__src__base__lib.aVertexPosition});`]));
        return _;
      })(), (() => {
        let _ = new lib__src__base__lib.ShaderObject("CubeMapF");
        _.AddVaryingVar(lib__src__base__lib.vVertexPosition);
        _.AddUniformVar(lib__src__base__lib.uCubeTexture);
        _.SetBodyWithMain(JSArrayOfString().of([dart.str`gl_FragColor = textureCube( ${lib__src__base__lib.uCubeTexture}, ${lib__src__base__lib.vVertexPosition} );`]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createCubeMapShader, VoidToListOfShaderObject());
  lib__src__shader__lib.createPointSpritesShader = function() {
    return JSArrayOfShaderObject().of([(() => {
        let _ = new lib__src__base__lib.ShaderObject("PointSprites");
        _.AddAttributeVar(lib__src__base__lib.aVertexPosition);
        _.AddUniformVar(lib__src__base__lib.uPerspectiveViewMatrix);
        _.AddUniformVar(lib__src__base__lib.uModelMatrix);
        _.AddUniformVar(lib__src__base__lib.uPointSize);
        _.SetBodyWithMain(JSArrayOfString().of([lib__src__shader__lib.StdVertexBody, dart.str`gl_PointSize = ${lib__src__base__lib.uPointSize}/gl_Position.z;`]));
        return _;
      })(), (() => {
        let _ = new lib__src__base__lib.ShaderObject("PointSpritesF");
        _.AddUniformVar(lib__src__base__lib.uTexture);
        _.SetBodyWithMain(JSArrayOfString().of([dart.str`gl_FragColor = texture2D( ${lib__src__base__lib.uTexture},  gl_PointCoord);`]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createPointSpritesShader, VoidToListOfShaderObject());
  lib__src__shader__lib.createDemoShader = function() {
    return JSArrayOfShaderObject().of([(() => {
        let _ = new lib__src__base__lib.ShaderObject("FixedVertexColorV");
        _.AddAttributeVar(lib__src__base__lib.aVertexPosition);
        _.AddUniformVar(lib__src__base__lib.uPerspectiveViewMatrix);
        _.AddUniformVar(lib__src__base__lib.uModelMatrix);
        _.AddVaryingVar(lib__src__base__lib.vColor);
        _.SetBodyWithMain(JSArrayOfString().of([lib__src__shader__lib.StdVertexBody, dart.str`${lib__src__base__lib.vColor} = ColorFromPosition(${lib__src__base__lib.aVertexPosition});`]), {prolog: JSArrayOfString().of([lib__src__shader__lib.StdLibShader])});
        return _;
      })(), (() => {
        let _ = new lib__src__base__lib.ShaderObject("FixedVertexColorF");
        _.AddVaryingVar(lib__src__base__lib.vColor);
        _.SetBodyWithMain(JSArrayOfString().of([dart.str`gl_FragColor = vec4( ${lib__src__base__lib.vColor}, 1.0 );`]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createDemoShader, VoidToListOfShaderObject());
  lib__src__shader__lib.createLightShaderGourad = function() {
    return JSArrayOfShaderObject().of([(() => {
        let _ = new lib__src__base__lib.ShaderObject("LightGouradV");
        _.AddAttributeVars(JSArrayOfString().of([lib__src__base__lib.aVertexPosition, lib__src__base__lib.aNormal, lib__src__base__lib.aTextureCoordinates]));
        _.AddVaryingVars(JSArrayOfString().of([lib__src__base__lib.vColor]));
        _.AddUniformVars(JSArrayOfString().of([lib__src__base__lib.uPerspectiveViewMatrix, lib__src__base__lib.uModelMatrix, lib__src__base__lib.uNormalMatrix]));
        _.AddUniformVars(JSArrayOfString().of([lib__src__base__lib.uLightDescs, lib__src__base__lib.uLightTypes, lib__src__base__lib.uShininess]));
        _.AddUniformVars(JSArrayOfString().of([lib__src__base__lib.uEyePosition, lib__src__base__lib.uTexture]));
        _.SetBody(JSArrayOfString().of([dart.str`    void main() {\n    vec4 pos = ${lib__src__base__lib.uModelMatrix} * vec4(${lib__src__base__lib.aVertexPosition}, 1.0);\n    gl_Position = ${lib__src__base__lib.uPerspectiveViewMatrix} * pos;\n    vec3 normal = ${lib__src__base__lib.uNormalMatrix} * ${lib__src__base__lib.aNormal};\n\n    ColorComponents acc = CombinedLight(pos.xyz, normal, ${lib__src__base__lib.uEyePosition},\n                  ${lib__src__base__lib.uLightDescs},\n                  ${lib__src__base__lib.uLightTypes},\n                  ${lib__src__base__lib.uShininess});\n\n     ${lib__src__base__lib.vColor} = acc.diffuse +\n                 acc.specular +\n                 texture2D(${lib__src__base__lib.uTexture}, ${lib__src__base__lib.aTextureCoordinates}).rgb;\n    }\n        `]), {prolog: JSArrayOfString().of([lib__src__shader__lib.StdLibShader])});
        return _;
      })(), (() => {
        let _ = new lib__src__base__lib.ShaderObject("LightGrouradV");
        _.AddVaryingVar(lib__src__base__lib.vColor);
        _.SetBodyWithMain(JSArrayOfString().of([dart.str`gl_FragColor = vec4(${lib__src__base__lib.vColor}, 1.0 );`]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createLightShaderGourad, VoidToListOfShaderObject());
  lib__src__shader__lib.createLightShaderBlinnPhong = function() {
    return JSArrayOfShaderObject().of([(() => {
        let _ = new lib__src__base__lib.ShaderObject("LightBlinnPhongV");
        _.AddAttributeVars(JSArrayOfString().of([lib__src__base__lib.aVertexPosition, lib__src__base__lib.aNormal, lib__src__base__lib.aTextureCoordinates]));
        _.AddVaryingVars(JSArrayOfString().of([lib__src__base__lib.vVertexPosition, lib__src__base__lib.vNormal, lib__src__base__lib.vTextureCoordinates]));
        _.AddUniformVars(JSArrayOfString().of([lib__src__base__lib.uPerspectiveViewMatrix, lib__src__base__lib.uModelMatrix, lib__src__base__lib.uNormalMatrix]));
        _.SetBodyWithMain(JSArrayOfString().of([dart.str`        vec4 pos = ${lib__src__base__lib.uModelMatrix} * vec4(${lib__src__base__lib.aVertexPosition}, 1.0);\n        gl_Position = ${lib__src__base__lib.uPerspectiveViewMatrix} * pos;\n        ${lib__src__base__lib.vVertexPosition} = pos.xyz;\n        ${lib__src__base__lib.vTextureCoordinates} = ${lib__src__base__lib.aTextureCoordinates};\n        ${lib__src__base__lib.vNormal} = ${lib__src__base__lib.uNormalMatrix} * ${lib__src__base__lib.aNormal};\n        `]));
        return _;
      })(), (() => {
        let _ = new lib__src__base__lib.ShaderObject("LightBlinnPhongF");
        _.AddVaryingVars(JSArrayOfString().of([lib__src__base__lib.vVertexPosition, lib__src__base__lib.vNormal, lib__src__base__lib.vTextureCoordinates]));
        _.AddUniformVars(JSArrayOfString().of([lib__src__base__lib.uLightDescs, lib__src__base__lib.uLightTypes, lib__src__base__lib.uShininess]));
        _.AddUniformVars(JSArrayOfString().of([lib__src__base__lib.uEyePosition, lib__src__base__lib.uTexture]));
        _.SetBodyWithMain(JSArrayOfString().of([dart.str`    ColorComponents acc = CombinedLight(${lib__src__base__lib.vVertexPosition},\n                                        ${lib__src__base__lib.vNormal},\n                                        ${lib__src__base__lib.uEyePosition},\n                                        ${lib__src__base__lib.uLightDescs},\n                                        ${lib__src__base__lib.uLightTypes},\n                                        ${lib__src__base__lib.uShininess});\n\n    gl_FragColor.rgb = acc.diffuse +\n                       acc.specular +\n                       texture2D(${lib__src__base__lib.uTexture}, ${lib__src__base__lib.vTextureCoordinates}).rgb;\n    gl_FragColor.a = 1.0;\n`]), {prolog: JSArrayOfString().of([lib__src__shader__lib.StdLibShader])});
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createLightShaderBlinnPhong, VoidToListOfShaderObject());
  lib__src__shader__lib.createBlurShader = function() {
    return JSArrayOfShaderObject().of([(() => {
        let _ = new lib__src__base__lib.ShaderObject("BlurV");
        _.AddAttributeVar(lib__src__base__lib.aVertexPosition);
        _.AddAttributeVar(lib__src__base__lib.aTextureCoordinates);
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.AddUniformVar(lib__src__base__lib.uPerspectiveViewMatrix);
        _.AddUniformVar(lib__src__base__lib.uModelMatrix);
        _.SetBodyWithMain(JSArrayOfString().of([lib__src__shader__lib.StdVertexBody, dart.str`${lib__src__base__lib.vTextureCoordinates} = ${lib__src__base__lib.aTextureCoordinates};`]));
        return _;
      })(), (() => {
        let _ = new lib__src__base__lib.ShaderObject("BlurF");
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.AddUniformVar(lib__src__base__lib.uCameraFar);
        _.AddUniformVar(lib__src__base__lib.uCameraNear);
        _.AddUniformVar(lib__src__base__lib.uCanvasSize);
        _.AddUniformVar(lib__src__base__lib.uTexture);
        _.SetBodyWithMain(JSArrayOfString().of([dart.str`      float offset[3];\n      offset[0]=0.;\n      offset[1]=1.3846153846;\n      offset[2]=3.2307692308;\n      float weight[3];\n      weight[0]=0.2270270270;\n      weight[1]=0.3162162162;\n      weight[2]=0.0702702703;\n\n      //gl_FragColor = vec4(gl_FragCoord.x/size.x, gl_FragCoord.y/size.y, 0., 0.);\n      //gl_FragColor = vec4(${lib__src__base__lib.vTextureCoordinates}.x, ${lib__src__base__lib.vTextureCoordinates}.y, 0., 0.);\n\n      gl_FragColor = texture2D( ${lib__src__base__lib.uTexture}, ${lib__src__base__lib.vTextureCoordinates})* weight[0];\n      for (int i=1; i<3; i++) {\n          gl_FragColor += texture2D( ${lib__src__base__lib.uTexture}, ${lib__src__base__lib.vTextureCoordinates}+vec2(0.0, offset[i]/size.y) ) * weight[i];\n          gl_FragColor += texture2D( ${lib__src__base__lib.uTexture}, ${lib__src__base__lib.vTextureCoordinates}-vec2(0.0, offset[i]/size.y) ) * weight[i];\n      }\n\n`]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createBlurShader, VoidToListOfShaderObject());
  lib__src__shader__lib.Blur2FragShader = "  float normpdf(in float x, in float sigma)\n  {\n    return 0.39894*exp(-0.5*x*x/(sigma*sigma))/sigma;\n  }\n  \n  void mainImage( out vec4 fragColor, in vec2 fragCoord )\n  {\n    vec3 c = texture2D(iChannel0, fragCoord.xy / iResolution.xy).rgb;\n      \n    //declare stuff\n    const int mSize = 21;\n    const int kSize = (mSize-1)/2;\n    float kernel[mSize];\n    vec3 final_colour = vec3(0.0);\n    \n    //create the 1-D kernel\n    float sigma = 7.0;\n    float Z = 0.0;\n    for (int j = 0; j <= kSize; ++j)\n    {\n      kernel[kSize+j] = kernel[kSize-j] = normpdf(float(j), sigma);\n    }\n    \n    //get the normalization factor (as the gaussian has been clamped)\n    for (int j = 0; j < mSize; ++j)\n    {\n      Z += kernel[j];\n    }\n    \n    //read out the texels\n    for (int i=-kSize; i <= kSize; ++i)\n    {\n      for (int j=-kSize; j <= kSize; ++j)\n      {\n        final_colour += kernel[kSize+j]*kernel[kSize+i]*texture2D(iChannel0, (fragCoord.xy+vec2(float(i),float(j))) / iResolution.xy).rgb;\n  \n      }\n    }\n    \n    \n    fragColor = vec4(final_colour/(Z*Z), 1.0);\n  }\n\n  void main(void)\n  {\n    mainImage( gl_FragColor, gl_FragCoord.xy);\n  }\n  ";
  lib__src__shader__lib.createBlurShader2 = function() {
    return JSArrayOfShaderObject().of([(() => {
        let _ = new lib__src__base__lib.ShaderObject("Blur2V");
        _.AddAttributeVar(lib__src__base__lib.aVertexPosition);
        _.AddUniformVar(lib__src__base__lib.uPerspectiveViewMatrix);
        _.AddUniformVar(lib__src__base__lib.uModelMatrix);
        _.SetBodyWithMain(JSArrayOfString().of([lib__src__shader__lib.StdVertexBody]));
        return _;
      })(), (() => {
        let _ = new lib__src__base__lib.ShaderObject("Blur2F");
        _.AddUniformVar(lib__src__base__lib.uCameraFar, "cameraFar");
        _.AddUniformVar(lib__src__base__lib.uCameraNear, "cameraNear");
        _.AddUniformVar(lib__src__base__lib.uCanvasSize, "iResolution");
        _.AddUniformVar(lib__src__base__lib.uTexture, "iChannel0");
        _.SetBody(JSArrayOfString().of([lib__src__shader__lib.Blur2FragShader]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createBlurShader2, VoidToListOfShaderObject());
  dart.defineLazy(lib__src__shader__lib, {
    get _effectVertexShader() {
      return (() => {
        let _ = new lib__src__base__lib.ShaderObject("copyV");
        _.AddAttributeVar(lib__src__base__lib.aVertexPosition);
        _.AddAttributeVar(lib__src__base__lib.aTextureCoordinates);
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.SetBodyWithMain(JSArrayOfString().of([lib__src__shader__lib.NullVertexBody, dart.str`${lib__src__base__lib.vTextureCoordinates} = ${lib__src__base__lib.aTextureCoordinates};`]));
        return _;
      })();
    },
    set _effectVertexShader(_) {}
  });
  lib__src__shader__lib.createCopyShader = function() {
    return JSArrayOfShaderObject().of([lib__src__shader__lib._effectVertexShader, (() => {
        let _ = new lib__src__base__lib.ShaderObject("copyF");
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.AddUniformVar(lib__src__base__lib.uTexture);
        _.SetBodyWithMain(JSArrayOfString().of([dart.str`gl_FragColor = texture2D(${lib__src__base__lib.uTexture}, ${lib__src__base__lib.vTextureCoordinates});`]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createCopyShader, VoidToListOfShaderObject());
  lib__src__shader__lib._libFragment = "vec3 RGBtoHSV(vec3 rgb) {\n   float r = rgb.r;\n   float g = rgb.g;\n   float b = rgb.b;\n\n\n   float minv = min(min(r, g), b);\n   float maxv = max(max(r, g), b);\n   float delta = maxv - minv;\n\n   vec3 res;\n   res.z = maxv;            // v\n   if( maxv == 0.0 ) {\n      // r = g = b = 0      // s = 0, v is undefined\n      res.y = 0.0;\n      res.x = -1.0;\n      return res;\n   }\n\n   res.y = delta / maxv;      // s\n   if (r == maxv) res.x = (g - b) / delta;  // btwn yellow & magenta\n   else if (g == maxv) res.x = 2.0 + (b - r) / delta;   // btwn cyan & yellow\n   else res.x = 4.0 + (r - g) / delta;   // btwn magenta & cyan\n\n   res.x = res.x * 60.0;            // degrees\n   if( res.x < 0.0 ) res.x = res.x + 360.0;\n\n   return res;\n}\n\nvec3 HSVtoRGB(vec3 hsv) {\n   float h = hsv.x / 60.0;  // sector 0 to 5\n   float s = hsv.y;\n   float v = hsv.z;\n\n   if( s == 0.0 ) {\n      // achromatic (grey)\n      return vec3(v, v, v);\n   }\n\n   int i = int(floor( h ));\n   float f = h - float(i);         // fractional part of h\n   float p = v * ( 1.0 - s );\n   float q = v * ( 1.0 - s * f );\n   float t = v * ( 1.0 - s * ( 1.0 - f ) );\n\n   if (i == 0) return vec3(v, t, p);\n   else if (i == 1) return vec3(q, v , p);\n   else if (i == 2) return vec3(p, v, t);\n   else if (i == 3) return vec3(p, q, v);\n   else if (i == 4) return vec3(t, p, v);\n   return vec3(v, p, q);\n}\n";
  dart.defineLazy(lib__src__shader__lib, {
    get _toonFragment() {
      return dart.str`\nfloat nearestLevel(float col, int mode) {\n   if (mode==0) return ceil(col / 80.0) * 80.0;\n\t else if (mode==1) return ceil(col * 6.0) / 6.0;\n\t else return ceil(col * 3.0) / 3.0;\n}\n\n// averaged pixel intensity from 3 color channels\nfloat avg3(vec3 pix) {\n return (pix.r + pix.g + pix.b)/3.0;\n}\n\nvec3 get_pixel(vec2 coords, float dx, float dy) {\n return texture2D(${lib__src__base__lib.uTexture}, coords + vec2(dx, dy)).rgb;\n}\n\n// returns pixel color\nfloat IsEdge(in vec2 coords) {\n  float dxtex = 1.0 / ${lib__src__base__lib.uCanvasSize}.x ;\n  float dytex = 1.0 / ${lib__src__base__lib.uCanvasSize}.y ;\n\n  // read neighboring pixel intensities\n  float pix0 = avg3(get_pixel(coords, -dxtex, -dytex));\n  float pix1 = avg3(get_pixel(coords, -dxtex, 0.0));\n  float pix2 = avg3(get_pixel(coords, -dxtex, dytex));\n  float pix3 = avg3(get_pixel(coords, 0.0, -dytex));\n\n  float pix5 = avg3(get_pixel(coords, 0.0, dytex));\n  float pix6 = avg3(get_pixel(coords, dxtex, -dytex));\n  float pix7 = avg3(get_pixel(coords, dxtex, 0.0));\n  float pix8 = avg3(get_pixel(coords, dxtex, dytex));\n\n\n  // average color differences around neighboring pixels\n  float delta = (abs(pix1-pix7) + abs(pix5-pix3) +\n                 abs(pix0-pix8) + abs(pix2-pix6)) * 0.25;\n  return clamp(5.5*delta, 0.0, 1.0);\n}\n\nvoid main() {\n    vec4 colorOrg = texture2D(${lib__src__base__lib.uTexture}, ${lib__src__base__lib.vTextureCoordinates});\n    vec3 vHSV =  RGBtoHSV(colorOrg.rgb);\n    vHSV.x = nearestLevel(vHSV.x, 0);\n    vHSV.y = nearestLevel(vHSV.y, 1);\n    vHSV.z = nearestLevel(vHSV.z, 2);\n    float edg = IsEdge(${lib__src__base__lib.vTextureCoordinates});\n    vec3 vRGB = (edg >= 0.3) ? vec3(0.0,0.0,0.0) : HSVtoRGB(vHSV);\n    //vec3 vRGB = HSVtoRGB(vHSV);\n    gl_FragColor = vec4(vRGB, 1.0);\n}\n`;
    },
    set _toonFragment(_) {}
  });
  lib__src__shader__lib.createToonShader = function() {
    return JSArrayOfShaderObject().of([lib__src__shader__lib._effectVertexShader, (() => {
        let _ = new lib__src__base__lib.ShaderObject("ToonF");
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.AddUniformVar(lib__src__base__lib.uCanvasSize);
        _.AddUniformVar(lib__src__base__lib.uTexture);
        _.SetBody(JSArrayOfString().of([lib__src__shader__lib._libFragment, lib__src__shader__lib._toonFragment]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createToonShader, VoidToListOfShaderObject());
  dart.defineLazy(lib__src__shader__lib, {
    get _hexPixelateFragment() {
      return dart.str`\nfloat S = 0.86602540378;\n\nvec2 GetHexCenter(vec2 p) {\n vec2 a;\n    if (p.x + p.y - floor(p.x) - floor(p.y) < 1.0) a = vec2(floor(p.x), floor(p.y));\n    else a = vec2(ceil(p.x), ceil(p.y));\n    vec2 b = vec2(ceil(p.x), floor(p.y));\n    vec2 c = vec2(floor(p.x), ceil(p.y));\n\n    vec3 P = vec3(p.x, p.y, 1.0 - p.x - p.y);\n    vec3 A = vec3(a.x, a.y, 1.0 - a.x - a.y);\n    vec3 B = vec3(b.x, b.y, 1.0 - b.x - b.y);\n    vec3 C = vec3(c.x, c.y, 1.0 - c.x - c.y);\n\n    float alen = length(P - A);\n    float blen = length(P - B);\n    float clen = length(P - C);\n\n    if (alen < blen) {\n        return (alen < clen) ? a : c;\n    } else {\n        return (blen < clen) ? b : c;\n    }\n}\n\nvec2 ToPixelSpace(vec2 v) {\n    vec2 p = (v * ${lib__src__base__lib.uCanvasSize} - ${lib__src__base__lib.uCenter2}) / ${lib__src__base__lib.uScale};\n    float t = p.y / S;\n    return vec2(p.x - 0.5 * t, t);\n}\n\nvec2 ToNormalizedSpace(vec2 v) {\n   vec2 p = vec2(v.x + v.y * 0.5, v.y * S);\n   return p * ${lib__src__base__lib.uScale} / ${lib__src__base__lib.uCanvasSize} + ${lib__src__base__lib.uCenter2} / ${lib__src__base__lib.uCanvasSize};\n}\n\nvoid main() {\n    vec2 p = ToPixelSpace(${lib__src__base__lib.vTextureCoordinates});\n    vec2 c = GetHexCenter(p);\n    vec2 q = ToNormalizedSpace(c);\n    gl_FragColor = texture2D(${lib__src__base__lib.uTexture}, q);\n}\n`;
    },
    set _hexPixelateFragment(_) {}
  });
  lib__src__shader__lib.createHexPixelateShader = function() {
    return JSArrayOfShaderObject().of([lib__src__shader__lib._effectVertexShader, (() => {
        let _ = new lib__src__base__lib.ShaderObject("HexPixelateF");
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.AddUniformVar(lib__src__base__lib.uCanvasSize);
        _.AddUniformVar(lib__src__base__lib.uCenter2);
        _.AddUniformVar(lib__src__base__lib.uScale);
        _.AddUniformVar(lib__src__base__lib.uTexture);
        _.SetBody(JSArrayOfString().of([lib__src__shader__lib._hexPixelateFragment]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createHexPixelateShader, VoidToListOfShaderObject());
  dart.defineLazy(lib__src__shader__lib, {
    get _dotFragment() {
      return dart.str`    float pattern(vec2 tex) {\n\t\t\tfloat s = sin( ${lib__src__base__lib.uAngle} );\n\t\t\tfloat c = cos( ${lib__src__base__lib.uAngle} );\n\t\t\tvec2 point = vec2( c * tex.x - s * tex.y, s * tex.x + c * tex.y ) * ${lib__src__base__lib.uScale};\n\t\t\treturn ( sin( point.x ) * sin( point.y ) ) * 4.0;\n    }\n\n\t\tvoid main() {\n\t\t\tvec4 color = texture2D(${lib__src__base__lib.uTexture}, ${lib__src__base__lib.vTextureCoordinates} );\n\t\t\tfloat average = ( color.r + color.g + color.b ) / 3.0;\n      vec2 tex = ${lib__src__base__lib.vTextureCoordinates}* ${lib__src__base__lib.uCanvasSize} - ${lib__src__base__lib.uCenter2};\n\t\t\tgl_FragColor = vec4( vec3( average * 10.0 - 5.0 + pattern(tex) ), color.a );\n\t\t}\n`;
    },
    set _dotFragment(_) {}
  });
  lib__src__shader__lib.createDotShader = function() {
    return JSArrayOfShaderObject().of([lib__src__shader__lib._effectVertexShader, (() => {
        let _ = new lib__src__base__lib.ShaderObject("DotF");
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.AddUniformVar(lib__src__base__lib.uCanvasSize);
        _.AddUniformVar(lib__src__base__lib.uCenter2);
        _.AddUniformVar(lib__src__base__lib.uScale);
        _.AddUniformVar(lib__src__base__lib.uAngle);
        _.AddUniformVar(lib__src__base__lib.uTexture);
        _.SetBody(JSArrayOfString().of([lib__src__shader__lib._dotFragment]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createDotShader, VoidToListOfShaderObject());
  dart.defineLazy(lib__src__shader__lib, {
    get _tvDistortionFragment() {
      return dart.str`float rand(vec2 co)  {\n    float a = 12.9898;\n    float b = 78.233;\n    float c = 43758.5453;\n    float dt = dot(co.xy, vec2(a,b));\n    float sn = mod(dt,3.14);\n    return fract(sin(sn) * c);\n}\n\nvec3 rgbDistortion(vec2 uv, float magnitude, float time) {\n    // x offset for the three color channels\n    // we do not change the y\n\t  float dR = rand(vec2(time * 0.03, uv.y * 0.42)) * 0.001 +\n\t             sin(rand(vec2(time * 0.2, uv.y))) * magnitude;\n\t  float dG = rand(vec2(time * 0.004, uv.y * 0.002)) * 0.004 +\n               sin(time * 9.0) * magnitude;\n\t  float dB = 0.0;\n    return vec3(dR, dG, dB);\n}\n\nvoid main() {\n      vec3 d = rgbDistortion(${lib__src__base__lib.vTextureCoordinates}, ${lib__src__base__lib.uScale}, ${lib__src__base__lib.uTime});\n      float x = ${lib__src__base__lib.vTextureCoordinates}.x;\n      float y = ${lib__src__base__lib.vTextureCoordinates}.y;\n\n\t\t\tfloat r = texture2D(${lib__src__base__lib.uTexture}, vec2(x + d.r, y) ).r;\n\t\t\tfloat g = texture2D(${lib__src__base__lib.uTexture}, vec2(x + d.g, y) ).g;\n\t\t\tfloat b = texture2D(${lib__src__base__lib.uTexture}, vec2(x + d.b, y) ).b;\n\t\t\tgl_FragColor = vec4( r, g, b, 1.0 );\n}\n`;
    },
    set _tvDistortionFragment(_) {}
  });
  lib__src__shader__lib.createTvDistortionShader = function() {
    return JSArrayOfShaderObject().of([lib__src__shader__lib._effectVertexShader, (() => {
        let _ = new lib__src__base__lib.ShaderObject("DotF");
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.AddUniformVar(lib__src__base__lib.uScale);
        _.AddUniformVar(lib__src__base__lib.uTime);
        _.AddUniformVar(lib__src__base__lib.uTexture);
        _.SetBody(JSArrayOfString().of([lib__src__shader__lib._tvDistortionFragment]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createTvDistortionShader, VoidToListOfShaderObject());
  dart.defineLazy(lib__src__shader__lib, {
    get _kaleidoscopeFragment() {
      return dart.str`vec2 kaleidoscope( vec2 uv, float n) {\n   float PI = 3.1415926;\n    float angle = PI / n;\n    float r = length(uv);\n\t  float a = atan( uv.y, uv.x ) / angle;\n\t  a = mix( fract( a ), 1.0 - fract( a ), mod( floor( a ), 2.0 ) ) * angle;\n\treturn vec2( cos( a ), sin( a ) ) * r;\n}\n\nvoid main() {\n    vec2 uv = kaleidoscope(${lib__src__base__lib.vTextureCoordinates} - ${lib__src__base__lib.uCenter2}, ${lib__src__base__lib.uScale});\n    gl_FragColor = texture2D(${lib__src__base__lib.uTexture}, uv + ${lib__src__base__lib.uCenter2});\n}\n`;
    },
    set _kaleidoscopeFragment(_) {}
  });
  lib__src__shader__lib.createKaleidoscopeShader = function() {
    return JSArrayOfShaderObject().of([lib__src__shader__lib._effectVertexShader, (() => {
        let _ = new lib__src__base__lib.ShaderObject("KaleidoscopeF");
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.AddUniformVar(lib__src__base__lib.uScale);
        _.AddUniformVar(lib__src__base__lib.uCenter2);
        _.AddUniformVar(lib__src__base__lib.uTexture);
        _.SetBody(JSArrayOfString().of([lib__src__shader__lib._kaleidoscopeFragment]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createKaleidoscopeShader, VoidToListOfShaderObject());
  dart.defineLazy(lib__src__shader__lib, {
    get _lumidotsFragment() {
      return dart.str`void main() {\n    float r = ${lib__src__base__lib.uPointSize};\n    vec2 uv = ${lib__src__base__lib.vTextureCoordinates} * ${lib__src__base__lib.uCanvasSize};\n    vec2 center = floor(uv / r / 2.0) * 2.0 * r + r;\n    vec3 col = texture2D(${lib__src__base__lib.uTexture}, center / ${lib__src__base__lib.uCanvasSize}).rgb;\n    float lum = max(0.1, dot(col, vec3(0.2125, 0.7154, 0.0721)));\n    float alpha =  smoothstep(1.0, 0.5,\n                              distance(center, uv) / lum / r);\n    gl_FragColor.rgb = col.rgb * alpha;\n}\n`;
    },
    set _lumidotsFragment(_) {}
  });
  lib__src__shader__lib.createLumidotsShader = function() {
    return JSArrayOfShaderObject().of([lib__src__shader__lib._effectVertexShader, (() => {
        let _ = new lib__src__base__lib.ShaderObject("LumidotsF");
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.AddUniformVar(lib__src__base__lib.uPointSize);
        _.AddUniformVar(lib__src__base__lib.uCanvasSize);
        _.AddUniformVar(lib__src__base__lib.uTexture);
        _.SetBody(JSArrayOfString().of([lib__src__shader__lib._lumidotsFragment]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createLumidotsShader, VoidToListOfShaderObject());
  dart.defineLazy(lib__src__shader__lib, {
    get _squarePixelateFragment() {
      return dart.str`void main() {\n    float r = ${lib__src__base__lib.uPointSize};\n    vec2 uv = ${lib__src__base__lib.vTextureCoordinates} * ${lib__src__base__lib.uCanvasSize};\n    vec2 center = floor(uv / r / 2.0) * 2.0 * r + r;\n    gl_FragColor = texture2D(${lib__src__base__lib.uTexture}, center / ${lib__src__base__lib.uCanvasSize});\n}\n`;
    },
    set _squarePixelateFragment(_) {}
  });
  lib__src__shader__lib.createSquarePixelateShader = function() {
    return JSArrayOfShaderObject().of([lib__src__shader__lib._effectVertexShader, (() => {
        let _ = new lib__src__base__lib.ShaderObject("SquarePixelateF");
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.AddUniformVar(lib__src__base__lib.uPointSize);
        _.AddUniformVar(lib__src__base__lib.uCanvasSize);
        _.AddUniformVar(lib__src__base__lib.uTexture);
        _.SetBody(JSArrayOfString().of([lib__src__shader__lib._squarePixelateFragment]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createSquarePixelateShader, VoidToListOfShaderObject());
  lib__src__shader__lib.createPlane2GreyShader = function() {
    return JSArrayOfShaderObject().of([(() => {
        let _ = new lib__src__base__lib.ShaderObject("Plane2GreyV");
        _.AddAttributeVar(lib__src__base__lib.aVertexPosition);
        _.AddAttributeVar(lib__src__base__lib.aNormal);
        _.AddVaryingVar(lib__src__base__lib.vColor);
        _.AddUniformVar(lib__src__base__lib.uPerspectiveViewMatrix);
        _.AddUniformVar(lib__src__base__lib.uModelMatrix);
        _.SetBodyWithMain(JSArrayOfString().of([dart.str`float d = sin(dot( ${lib__src__base__lib.aVertexPosition}, ${lib__src__base__lib.aNormal})) / 2.0 + 0.5;`, dart.str`${lib__src__base__lib.vColor} = vec3(d,d,d);`, lib__src__shader__lib.StdVertexBody]));
        return _;
      })(), (() => {
        let _ = new lib__src__base__lib.ShaderObject("Plane2GreyF");
        _.AddVaryingVar(lib__src__base__lib.vColor);
        _.SetBodyWithMain(JSArrayOfString().of([dart.str`gl_FragColor = vec4(${lib__src__base__lib.vColor}, 1.0);`]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createPlane2GreyShader, VoidToListOfShaderObject());
  lib__src__shader__lib._VertexShaderPlane2ColorV = dart.str`vec3 HSV2RGB( vec3 hsv )\n{\n    hsv.x = mod( 100.0 + hsv.x, 1.0 ); // Ensure [0,1[\n    float   HueSlice = 6.0 * hsv.x; // In [0,6[\n    float   HueSliceInteger = floor( HueSlice );\n    float   HueSliceInterpolant = HueSlice - HueSliceInteger; // In [0,1[ for each hue slice\n    vec3  TempRGB = vec3(   hsv.z * (1.0 - hsv.y), hsv.z * (1.0 - hsv.y * HueSliceInterpolant), hsv.z * (1.0 - hsv.y * (1.0 - HueSliceInterpolant)) );\n    float   IsOddSlice = mod( HueSliceInteger, 2.0 ); // 0 if even (slices 0, 2, 4), 1 if odd (slices 1, 3, 5)\n    float   ThreeSliceSelector = 0.5 * (HueSliceInteger - IsOddSlice); // (0, 1, 2) corresponding to slices (0, 2, 4) and (1, 3, 5)\n    vec3  ScrollingRGBForEvenSlices = vec3( hsv.z, TempRGB.zx );           // (V, Temp Blue, Temp Red) for even slices (0, 2, 4)\n    vec3  ScrollingRGBForOddSlices = vec3( TempRGB.y, hsv.z, TempRGB.x );  // (Temp Green, V, Temp Red) for odd slices (1, 3, 5)\n    vec3  ScrollingRGB = mix( ScrollingRGBForEvenSlices, ScrollingRGBForOddSlices, IsOddSlice );\n    float   IsNotFirstSlice = clamp( ThreeSliceSelector, 0.0,1.0 ); // 1 if NOT the first slice (true for slices 1 and 2)\n    float   IsNotSecondSlice = clamp( ThreeSliceSelector-1.0, 0.0,1. ); // 1 if NOT the first or second slice (true only for slice 2)\n    return  mix( ScrollingRGB.xyz, mix( ScrollingRGB.zxy, ScrollingRGB.yzx, IsNotSecondSlice ), IsNotFirstSlice ); // Make the RGB rotate right depending on final slice index\n}\n\nvoid main(void) {\n  gl_Position = ${lib__src__base__lib.uPerspectiveViewMatrix} * ${lib__src__base__lib.uModelMatrix} * vec4(${lib__src__base__lib.aVertexPosition}, 1.0);\n  float d=dot( ${lib__src__base__lib.aVertexPosition}, ${lib__src__base__lib.aNormal});\n  vec3 hsv = vec3(d,1,1);\n  ${lib__src__base__lib.vColor} = HSV2RGB(hsv);\n}\n`;
  lib__src__shader__lib.createPlane2ColorShader = function() {
    return JSArrayOfShaderObject().of([(() => {
        let _ = new lib__src__base__lib.ShaderObject("Plane2ColorV");
        _.AddAttributeVar(lib__src__base__lib.aVertexPosition);
        _.AddAttributeVar(lib__src__base__lib.aNormal);
        _.AddUniformVar(lib__src__base__lib.uPerspectiveViewMatrix);
        _.AddUniformVar(lib__src__base__lib.uModelMatrix);
        _.AddVaryingVar(lib__src__base__lib.vColor);
        _.SetBody(JSArrayOfString().of([lib__src__shader__lib._VertexShaderPlane2ColorV]));
        return _;
      })(), (() => {
        let _ = new lib__src__base__lib.ShaderObject("Plane2ColorF");
        _.AddVaryingVar(lib__src__base__lib.vColor);
        _.SetBodyWithMain(JSArrayOfString().of(["gl_FragColor = vec4( vColor, 1.0 );"]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createPlane2ColorShader, VoidToListOfShaderObject());
  dart.defineLazy(lib__src__shader__lib, {
    get _SSAOShaderImpl() {
      return dart.str`    //uniform bool fogEnabled;\n    const bool fogEnabled=false;\n\n    //uniform bool onlyAO;\n    const bool onlyAO=false;\n\n\n    //uniform float aoClamp;\n    const float aoClamp = 0.45;\n\n    //uniform float lumInfluence;\n    const float lumInfluence = 0.4;\n\n    //varying vec2 vUv;\n    \n    #define DL 2.399963229728653\n    #define EULER 2.718281828459045\n    \n    float width = ${lib__src__base__lib.uCanvasSize}.x;\n    float height = ${lib__src__base__lib.uCanvasSize}.y;\n    float cameraFarPlusNear = ${lib__src__base__lib.uCameraFar} + ${lib__src__base__lib.uCameraNear};\n    float cameraFarMinusNear = ${lib__src__base__lib.uCameraFar} - ${lib__src__base__lib.uCameraNear};\n    float cameraCoef = 2.0 * ${lib__src__base__lib.uCameraNear};\n    \n    const int samples = 8;\n    const float radius = 5.0;\n    const bool useNoise = false;\n    const float noiseAmount = 0.0003;\n    const float diffArea = 0.4;\n    const float gDisplace = 0.4;\n    const vec3 onlyAOColor = vec3( 1.0, 0.7, 0.5 );\n    \n    float unpackDepth( const in vec4 rgba_depth ) {\n      return rgba_depth.r;\n    }\n    float unpackDepth2( const in vec4 rgba_depth ) {\n      const vec4 bit_shift = vec4( 1.0 / ( 256.0 * 256.0 * 256.0 ), 1.0 / ( 256.0 * 256.0 ), 1.0 / 256.0, 1.0 );\n      float depth = dot( rgba_depth, bit_shift );\n      return depth;\n    }\n    \n    vec2 rand( const vec2 coord ) {\n      vec2 noise;\n      if ( useNoise ) {\n        float nx = dot ( coord, vec2( 12.9898, 78.233 ) );\n        float ny = dot ( coord, vec2( 12.9898, 78.233 ) * 2.0 );\n        noise = clamp( fract ( 43758.5453 * sin( vec2( nx, ny ) ) ), 0.0, 1.0 );\n      } else {\n        float ff = fract( 1.0 - coord.s * ( width / 2.0 ) );\n        float gg = fract( coord.t * ( height / 2.0 ) );\n        noise = vec2( 0.25, 0.75 ) * vec2( ff ) + vec2( 0.75, 0.25 ) * gg;\n      }\n      return ( noise * 2.0  - 1.0 ) * noiseAmount;\n    }\n    \n/*\n    float doFog() {\n      float zdepth = unpackDepth( texture2D(${lib__src__base__lib.uDepthMap}, ${lib__src__base__lib.vTextureCoordinates} ) );\n      float depth = -cameraFar * cameraNear / ( zdepth * cameraFarMinusNear - cameraFar );\n      return smoothstep( fogNear, fogFar, depth );\n    }\n*/  \n\n    float readDepth( const in vec2 coord ) {\n      return cameraCoef / ( cameraFarPlusNear - unpackDepth( texture2D(${lib__src__base__lib.uDepthMap}, coord ) ) * cameraFarMinusNear );\n    }\n    \n    float compareDepths( const in float depth1, const in float depth2, inout int far ) {\n      float garea = 2.0;\n      float diff = ( depth1 - depth2 ) * 100.0;\n      if ( diff < gDisplace ) {\n        garea = diffArea;\n      } else {\n        far = 1;\n      }\n    \n      float dd = diff - gDisplace;\n      float gauss = pow( EULER, -2.0 * dd * dd / ( garea * garea ) );\n      return gauss;\n    }\n    \n    float calcAO( float depth, float dw, float dh ) {\n      float dd = radius - depth * radius;\n      vec2 vv = vec2( dw, dh );\n      vec2 coord1 = ${lib__src__base__lib.vTextureCoordinates} + dd * vv;\n      vec2 coord2 = ${lib__src__base__lib.vTextureCoordinates} - dd * vv;\n      float temp1 = 0.0;\n      float temp2 = 0.0;\n      int far = 0;\n      temp1 = compareDepths( depth, readDepth( coord1 ), far );\n      if ( far > 0 ) {\n        temp2 = compareDepths( readDepth( coord2 ), depth, far );\n        temp1 += ( 1.0 - temp1 ) * temp2;\n      }\n      return temp1;\n    }\n    \n    void main() {\n      vec2 noise = rand( ${lib__src__base__lib.vTextureCoordinates} );\n      float depth = readDepth( ${lib__src__base__lib.vTextureCoordinates} );\n      float tt = clamp( depth, aoClamp, 1.0 );\n      float w = ( 1.0 / width )  / tt + ( noise.x * ( 1.0 - noise.x ) );\n      float h = ( 1.0 / height ) / tt + ( noise.y * ( 1.0 - noise.y ) );\n      float pw;\n      float ph;\n      float ao;\n      float dz = 1.0 / float( samples );\n      float z = 1.0 - dz / 2.0;\n      float l = 0.0;\n      for ( int i = 0; i <= samples; i ++ ) {\n        float r = sqrt( 1.0 - z );\n        pw = cos( l ) * r;\n        ph = sin( l ) * r;\n        ao += calcAO( depth, pw * w, ph * h );\n        z = z - dz;\n        l = l + DL;\n      }\n    \n      ao /= float( samples );\n      ao = 1.0 - ao;\n\n/*\n      if ( fogEnabled ) {\n        ao = mix( ao, 1.0, doFog() );\n      }\n*/\n\n      // Diffuse\n      vec3 color = texture2D(${lib__src__base__lib.uTexture}, ${lib__src__base__lib.vTextureCoordinates} ).rgb;\n      vec3 lumcoeff = vec3( 0.299, 0.587, 0.114 );\n      float lum = dot( color.rgb, lumcoeff );\n      vec3 luminance = vec3( lum );\n      vec3 final = vec3( color * mix( vec3( ao ), vec3( 1.0 ), luminance * lumInfluence ) );\n    \n      if ( onlyAO ) {\n        final = onlyAOColor * vec3( mix( vec3( ao ), vec3( 1.0 ), luminance * lumInfluence ) );\n      }\n      gl_FragColor = vec4( final, 1.0 );\n      //gl_FragColor = vec4( color, 1.0 );\n    }\n    \n    `;
    },
    set _SSAOShaderImpl(_) {}
  });
  lib__src__shader__lib.createSSAOShader = function() {
    return JSArrayOfShaderObject().of([(() => {
        let _ = new lib__src__base__lib.ShaderObject("SSAOV");
        _.AddAttributeVar(lib__src__base__lib.aVertexPosition);
        _.AddAttributeVar(lib__src__base__lib.aTextureCoordinates);
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.SetBodyWithMain(JSArrayOfString().of([lib__src__shader__lib.NullVertexBody, lib__src__shader__lib.StdVertexTextureForward]));
        return _;
      })(), (() => {
        let _ = new lib__src__base__lib.ShaderObject("SSAOF");
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.AddUniformVar(lib__src__base__lib.uCanvasSize);
        _.AddUniformVar(lib__src__base__lib.uCameraNear);
        _.AddUniformVar(lib__src__base__lib.uCameraFar);
        _.AddUniformVar(lib__src__base__lib.uTexture);
        _.AddUniformVar(lib__src__base__lib.uDepthMap);
        _.SetBody(JSArrayOfString().of([lib__src__shader__lib._SSAOShaderImpl]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createSSAOShader, VoidToListOfShaderObject());
  lib__src__shader__lib.createSobelShader = function() {
    return JSArrayOfShaderObject().of([(() => {
        let _ = new lib__src__base__lib.ShaderObject("SobelV");
        _.AddAttributeVar(lib__src__base__lib.aVertexPosition);
        _.AddAttributeVar(lib__src__base__lib.aTextureCoordinates);
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.SetBodyWithMain(JSArrayOfString().of([lib__src__shader__lib.NullVertexBody, lib__src__shader__lib.StdVertexTextureForward]));
        return _;
      })(), (() => {
        let _ = new lib__src__base__lib.ShaderObject("SobelF");
        _.AddVaryingVar(lib__src__base__lib.vTextureCoordinates);
        _.AddUniformVar(lib__src__base__lib.uTexture);
        _.AddUniformVar(lib__src__base__lib.uCanvasSize);
        _.SetBody(JSArrayOfString().of([dart.str`  float lum(vec4 c) {\n    return dot(c.xyz, vec3(0.3, 0.59, 0.11));\n  }\n\n\n  float sobel() {\n      vec2 imageIncrement = vec2(1.0/${lib__src__base__lib.uCanvasSize}.x,1.0/${lib__src__base__lib.uCanvasSize}.y);\n      float t00 = lum(texture2D(${lib__src__base__lib.uTexture}, vTextureCoordinates + imageIncrement * vec2(-1, -1)));\n      float t10 = lum(texture2D(${lib__src__base__lib.uTexture}, vTextureCoordinates + imageIncrement * vec2( 0, -1)));\n      float t20 = lum(texture2D(${lib__src__base__lib.uTexture}, vTextureCoordinates + imageIncrement * vec2( 1, -1)));\n      float t01 = lum(texture2D(${lib__src__base__lib.uTexture}, vTextureCoordinates + imageIncrement * vec2(-1,  0)));\n      float t21 = lum(texture2D(${lib__src__base__lib.uTexture}, vTextureCoordinates + imageIncrement * vec2( 1,  0)));\n      float t02 = lum(texture2D(${lib__src__base__lib.uTexture}, vTextureCoordinates + imageIncrement * vec2(-1,  1)));\n      float t12 = lum(texture2D(${lib__src__base__lib.uTexture}, vTextureCoordinates + imageIncrement * vec2( 0,  1)));\n      float t22 = lum(texture2D(${lib__src__base__lib.uTexture}, vTextureCoordinates + imageIncrement * vec2( 1,  1)));\n      vec2 grad;\n      grad.x = t00 + 2.0 * t01 + t02 - t20 - 2.0 * t21 - t22;\n      grad.y = t00 + 2.0 * t10 + t20 - t02 - 2.0 * t12 - t22;\n      return length(grad);\n  } \n\n  void main(void) {\n      float len = sobel();\n      gl_FragColor = vec4(len, len, len, 1.0); // \n  }\n  `]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createSobelShader, VoidToListOfShaderObject());
  lib__src__shader__lib.perlinNoisefunctions = "vec3 mod289(vec3 x)\n{\n  return x - floor(x * (1.0 / 289.0)) * 289.0;\n}\n\nvec4 mod289(vec4 x)\n{\n  return x - floor(x * (1.0 / 289.0)) * 289.0;\n}\n\nvec4 permute(vec4 x)\n{\n  return mod289(((x*34.0)+1.0)*x);\n}\n\nvec4 taylorInvSqrt(vec4 r)\n{\n  return 1.79284291400159 - 0.85373472095314 * r;\n}\n\nvec3 fade(vec3 t) {\n  return t*t*t*(t*(t*6.0-15.0)+10.0);\n}\n\n\n// Classic Perlin noise, periodic variant\nfloat pnoise(vec3 P, vec3 rep)\n{\n  vec3 Pi0 = mod(floor(P), rep); // Integer part, modulo period\n  vec3 Pi1 = mod(Pi0 + vec3(1.0), rep); // Integer part + 1, mod period\n  Pi0 = mod289(Pi0);\n  Pi1 = mod289(Pi1);\n  vec3 Pf0 = fract(P); // Fractional part for interpolation\n  vec3 Pf1 = Pf0 - vec3(1.0); // Fractional part - 1.0\n  vec4 ix = vec4(Pi0.x, Pi1.x, Pi0.x, Pi1.x);\n  vec4 iy = vec4(Pi0.yy, Pi1.yy);\n  vec4 iz0 = Pi0.zzzz;\n  vec4 iz1 = Pi1.zzzz;\n\n  vec4 ixy = permute(permute(ix) + iy);\n  vec4 ixy0 = permute(ixy + iz0);\n  vec4 ixy1 = permute(ixy + iz1);\n\n  vec4 gx0 = ixy0 * (1.0 / 7.0);\n  vec4 gy0 = fract(floor(gx0) * (1.0 / 7.0)) - 0.5;\n  gx0 = fract(gx0);\n  vec4 gz0 = vec4(0.5) - abs(gx0) - abs(gy0);\n  vec4 sz0 = step(gz0, vec4(0.0));\n  gx0 -= sz0 * (step(0.0, gx0) - 0.5);\n  gy0 -= sz0 * (step(0.0, gy0) - 0.5);\n\n  vec4 gx1 = ixy1 * (1.0 / 7.0);\n  vec4 gy1 = fract(floor(gx1) * (1.0 / 7.0)) - 0.5;\n  gx1 = fract(gx1);\n  vec4 gz1 = vec4(0.5) - abs(gx1) - abs(gy1);\n  vec4 sz1 = step(gz1, vec4(0.0));\n  gx1 -= sz1 * (step(0.0, gx1) - 0.5);\n  gy1 -= sz1 * (step(0.0, gy1) - 0.5);\n\n  vec3 g000 = vec3(gx0.x,gy0.x,gz0.x);\n  vec3 g100 = vec3(gx0.y,gy0.y,gz0.y);\n  vec3 g010 = vec3(gx0.z,gy0.z,gz0.z);\n  vec3 g110 = vec3(gx0.w,gy0.w,gz0.w);\n  vec3 g001 = vec3(gx1.x,gy1.x,gz1.x);\n  vec3 g101 = vec3(gx1.y,gy1.y,gz1.y);\n  vec3 g011 = vec3(gx1.z,gy1.z,gz1.z);\n  vec3 g111 = vec3(gx1.w,gy1.w,gz1.w);\n\n  vec4 norm0 = taylorInvSqrt(vec4(dot(g000, g000), dot(g010, g010), dot(g100, g100), dot(g110, g110)));\n  g000 *= norm0.x;\n  g010 *= norm0.y;\n  g100 *= norm0.z;\n  g110 *= norm0.w;\n  vec4 norm1 = taylorInvSqrt(vec4(dot(g001, g001), dot(g011, g011), dot(g101, g101), dot(g111, g111)));\n  g001 *= norm1.x;\n  g011 *= norm1.y;\n  g101 *= norm1.z;\n  g111 *= norm1.w;\n\n  float n000 = dot(g000, Pf0);\n  float n100 = dot(g100, vec3(Pf1.x, Pf0.yz));\n  float n010 = dot(g010, vec3(Pf0.x, Pf1.y, Pf0.z));\n  float n110 = dot(g110, vec3(Pf1.xy, Pf0.z));\n  float n001 = dot(g001, vec3(Pf0.xy, Pf1.z));\n  float n101 = dot(g101, vec3(Pf1.x, Pf0.y, Pf1.z));\n  float n011 = dot(g011, vec3(Pf0.x, Pf1.yz));\n  float n111 = dot(g111, Pf1);\n\n  vec3 fade_xyz = fade(Pf0);\n  vec4 n_z = mix(vec4(n000, n100, n010, n110), vec4(n001, n101, n011, n111), fade_xyz.z);\n  vec2 n_yz = mix(n_z.xy, n_z.zw, fade_xyz.y);\n  float n_xyz = mix(n_yz.x, n_yz.y, fade_xyz.x); \n  return 2.2 * n_xyz;\n}\n";
  lib__src__shader__lib.createPerlinNoiseColorShader = function(blackVariant) {
    let define = "";
    let name = "PerlinNoiseColor";
    if (dart.test(blackVariant)) {
      define = "#define BLACK 1";
      name = "Black" + name;
    }
    return JSArrayOfShaderObject().of([(() => {
        let _ = new lib__src__base__lib.ShaderObject(name + "V");
        _.AddAttributeVar(lib__src__base__lib.aVertexPosition);
        _.AddVaryingVar(lib__src__base__lib.vNormal);
        _.AddUniformVar(lib__src__base__lib.uPerspectiveViewMatrix);
        _.AddUniformVar(lib__src__base__lib.uModelMatrix);
        _.AddUniformVar(lib__src__base__lib.uTime);
        _.SetBody(JSArrayOfString().of([lib__src__shader__lib.perlinNoisefunctions, dart.str`void main() {\n        vec3 normal = normalize( ${lib__src__base__lib.aVertexPosition});\n        float f = 0.5 * pnoise( normal + ${lib__src__base__lib.uTime}/3.0, vec3( 10.0 ) );\n        //vNormal = ${lib__src__base__lib.aVertexPosition} + f * normal;\n        //vNormal = f*normal;\n        ${lib__src__base__lib.vNormal} = normal;\n        gl_Position = ${lib__src__base__lib.uPerspectiveViewMatrix} * ${lib__src__base__lib.uModelMatrix} * vec4(${lib__src__base__lib.aVertexPosition}, 1.0);\n}\n      `]));
        return _;
      })(), (() => {
        let _ = new lib__src__base__lib.ShaderObject(name + " F");
        _.AddVaryingVar(lib__src__base__lib.vNormal);
        _.AddUniformVar(lib__src__base__lib.uTime);
        _.AddUniformVar(lib__src__base__lib.uTransformationMatrix);
        _.SetBody(JSArrayOfString().of([define, lib__src__shader__lib.perlinNoisefunctions, dart.str`#define VARIANT 1\n\nvoid main() {\n#if VARIANT == 1\n  float mytime = ${lib__src__base__lib.uTime}/2.0;\n#ifdef BLACK\n  mytime = ${lib__src__base__lib.uTime}/10.0;\n#endif\n  float period = 10.0;\n  float factor = 1.0; // sin( ${lib__src__base__lib.uTime})/4.0+2.0;\n  vec3 translation = ${lib__src__base__lib.uTransformationMatrix}[3].xyz;\n  float r = pnoise( .75 * ( vNormal*factor + mytime ), vec3( period ) );\n  float g = pnoise( 0.8 * ( vNormal*factor + mytime ), vec3( period ) );\n  float b = pnoise( 0.9 * ( vNormal*factor + mytime ), vec3( period ) );\n  float n = pnoise( 1.5 * ( vNormal*factor + mytime ), vec3( period ) );\n#else\n  float mytime = 0.0 ; //${lib__src__base__lib.uTime}/50.0;\n  float period = 5.0;\n  float factor = 1.0; // sin( ${lib__src__base__lib.uTime})/4.0+2.0;\n  vec3 translation = ${lib__src__base__lib.uTransformationMatrix}[3].xyz;\n  float r = pnoise( .75 * ( translation*0.175 + vNormal*factor + mytime ), vec3( period ) );\n  float g = pnoise( 0.8 * ( translation*0.175 + vNormal*factor + mytime ), vec3( period ) );\n  float b = pnoise( 0.9 * ( translation*0.175 + vNormal*factor + mytime ), vec3( period ) );\n  float n = pnoise( 1.5 * ( translation*0.175 + vNormal*factor + mytime ), vec3( period ) );\n#endif\n\n  n = pow( .001, n );\n//float n = 10.0 * pnoise( 5.0 * ( vNormal + ${lib__src__base__lib.uTime} ), vec3( 10.0 ) ) * pnoise( .5 * ( vNormal + ${lib__src__base__lib.uTime} ), vec3( 10.0 ) );\n//n += .5 * pnoise( 4.0 * vNormal, vec3( 10.0 ) );\n#ifdef BLACK\n  vec3 color = vec3( 1.0-(r + n), 1.0-(g + n), 1.0-(b + n) );\n#else\n  vec3 color = vec3( (r + n), (g + n), (b + n) );\n#endif\n  gl_FragColor = vec4( color, 1.0 );\n}\n`]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createPerlinNoiseColorShader, boolToListOfShaderObject());
  dart.defineLazy(lib__src__shader__lib, {
    get _WireframeF() {
      return dart.str`#extension GL_OES_standard_derivatives : enable\n\n\n// the 3 vertices of a Face3 (w == 0) have the centers:\n// (1, 0, 0, 0)) \n// (0, 1, 0, 0)\n// (0, 0, 1, 0)\nfloat edgeFactorFace3(vec3 center) {\n    vec3 d = fwidth(center);\n    vec3 a3 = smoothstep(vec3(0.0), d * 1.5, center);\n    return min(min(a3.x, a3.y), a3.z);\n}\n\n// the 4 vertices of a Face4 (w == 1) have the centers:\n// (1, 0, 0, 1) \n// (1, 1, 0, 1)\n// (0, 1, 0, 1)\n// (0, 0, 0, 1)\nfloat edgeFactorFace4(vec2 center) {\n    vec2 d = fwidth(center);\n    vec2 a2 = smoothstep(vec2(0.0), d * 1.5, center);\n    return min(a2.x, a2.y);\n}\n\nvoid main() {\n    vec4 color;\n    if (${lib__src__base__lib.vCenter}.w == 0.0) {\n        color = mix(${lib__src__base__lib.uColorAlpha}, ${lib__src__base__lib.uColorAlpha2}, \n                        edgeFactorFace3(${lib__src__base__lib.vCenter}.xyz));\n    } else {\n        color = mix(${lib__src__base__lib.uColorAlpha}, ${lib__src__base__lib.uColorAlpha2},    \n                    min(edgeFactorFace4(${lib__src__base__lib.vCenter}.xy), \n                        edgeFactorFace4(1.0 - ${lib__src__base__lib.vCenter}.xy)));\n    }\n    gl_FragColor = color;\n}\n`;
    },
    set _WireframeF(_) {}
  });
  lib__src__shader__lib.createWireframeShader = function() {
    return JSArrayOfShaderObject().of([(() => {
        let _ = new lib__src__base__lib.ShaderObject("WireframeV");
        _.AddAttributeVar(lib__src__base__lib.aVertexPosition);
        _.AddAttributeVar(lib__src__base__lib.aCenter);
        _.AddVaryingVar(lib__src__base__lib.vCenter);
        _.AddUniformVar(lib__src__base__lib.uPerspectiveViewMatrix);
        _.AddUniformVar(lib__src__base__lib.uModelMatrix);
        _.SetBodyWithMain(JSArrayOfString().of([lib__src__shader__lib.StdVertexBody, dart.str`${lib__src__base__lib.vCenter} = ${lib__src__base__lib.aCenter};`]));
        return _;
      })(), (() => {
        let _ = new lib__src__base__lib.ShaderObject("WireframeF");
        _.AddVaryingVar(lib__src__base__lib.vCenter);
        _.AddUniformVar(lib__src__base__lib.uColorAlpha);
        _.AddUniformVar(lib__src__base__lib.uColorAlpha2);
        _.SetBody(JSArrayOfString().of([lib__src__shader__lib._WireframeF]));
        return _;
      })()]);
  };
  dart.fn(lib__src__shader__lib.createWireframeShader, VoidToListOfShaderObject());
  dart.trackLibraries("lib_shader", {"lib/src/shader/lib.dart": lib__src__shader__lib}, null);
  // Exports:
  exports.lib__src__shader__lib = lib__src__shader__lib;
}));
