dart_library.library('lib_webhelper', null, /* Imports */[
  'dart_sdk',
  'lib_core',
  'pub_vector_math'
], (function load__lib_webhelper(exports, dart_sdk, lib_core, pub_vector_math) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const html = dart_sdk.html;
  const convert = dart_sdk.convert;
  const _interceptors = dart_sdk._interceptors;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  let lib__src__core__lib = dart_library.defer(lib_core, "lib__src__core__lib", function(mod, lib) {
    lib_core = mod;
    lib__src__core__lib = lib;
  });
  let vector_math = dart_library.defer(pub_vector_math, "vector_math", function(mod, lib) {
    pub_vector_math = mod;
    vector_math = lib;
  });
  const lib__src__webhelper__lib = Object.create(null);
  let FutureOfString = () => (FutureOfString = dart.constFn(async.Future$(core.String)))();
  let FutureOfImageElement = () => (FutureOfImageElement = dart.constFn(async.Future$(html.ImageElement)))();
  let FutureOfVideoElement = () => (FutureOfVideoElement = dart.constFn(async.Future$(html.VideoElement)))();
  let JSArrayOfString = () => (JSArrayOfString = dart.constFn(_interceptors.JSArray$(core.String)))();
  let ListOfFutureOfImageElement = () => (ListOfFutureOfImageElement = dart.constFn(core.List$(FutureOfImageElement())))();
  let ProgressEventToNull = () => (ProgressEventToNull = dart.constFn(dart.definiteFunctionType(core.Null, [html.ProgressEvent])))();
  let StringToFutureOfString = () => (StringToFutureOfString = dart.constFn(dart.definiteFunctionType(FutureOfString(), [core.String])))();
  let EventTovoid = () => (EventTovoid = dart.constFn(dart.definiteFunctionType(dart.void, [html.Event])))();
  let StringToFutureOfImageElement = () => (StringToFutureOfImageElement = dart.constFn(dart.definiteFunctionType(FutureOfImageElement(), [core.String])))();
  let StringToFutureOfVideoElement = () => (StringToFutureOfVideoElement = dart.constFn(dart.definiteFunctionType(FutureOfVideoElement(), [core.String])))();
  let StringAndStringToListOfFutureOfImageElement = () => (StringAndStringToListOfFutureOfImageElement = dart.constFn(dart.definiteFunctionType(ListOfFutureOfImageElement(), [core.String, core.String])))();
  let dynamicToNull = () => (dynamicToNull = dart.constFn(dart.definiteFunctionType(core.Null, [dart.dynamic])))();
  let MediaStreamToNull = () => (MediaStreamToNull = dart.constFn(dart.definiteFunctionType(core.Null, [html.MediaStream])))();
  let VoidToFutureOfVideoElement = () => (VoidToFutureOfVideoElement = dart.constFn(dart.definiteFunctionType(FutureOfVideoElement(), [])))();
  let StringToCanvasElement = () => (StringToCanvasElement = dart.constFn(dart.definiteFunctionType(html.CanvasElement, [core.String])))();
  let ChronosGLAndStringAndStringToTexture = () => (ChronosGLAndStringAndStringToTexture = dart.constFn(dart.definiteFunctionType(lib__src__core__lib.Texture, [lib__src__core__lib.ChronosGL, core.String, core.String])))();
  let ChronosGLAndStringAndVector3ToTexture = () => (ChronosGLAndStringAndVector3ToTexture = dart.constFn(dart.definiteFunctionType(lib__src__core__lib.Texture, [lib__src__core__lib.ChronosGL, core.String, vector_math.Vector3])))();
  let ChronosGLAndStringAndVector4ToTexture = () => (ChronosGLAndStringAndVector4ToTexture = dart.constFn(dart.definiteFunctionType(lib__src__core__lib.Texture, [lib__src__core__lib.ChronosGL, core.String, vector_math.Vector4])))();
  lib__src__webhelper__lib.LoadRaw = function(url) {
    let c = async.Completer.new();
    let hr = html.HttpRequest.new();
    hr.open("GET", url);
    hr[dartx.onLoadEnd].listen(dart.fn(e => {
      c.complete(hr[dartx.response]);
    }, ProgressEventToNull()));
    hr.send('');
    return FutureOfString().as(c.future);
  };
  dart.fn(lib__src__webhelper__lib.LoadRaw, StringToFutureOfString());
  lib__src__webhelper__lib.LoadJson = function(url) {
    let c = async.Completer.new();
    let hr = html.HttpRequest.new();
    hr.open("GET", url);
    hr[dartx.onLoadEnd].listen(dart.fn(e => {
      c.complete(convert.JSON.decode(core.String._check(hr[dartx.response])));
    }, ProgressEventToNull()));
    hr.send('');
    return FutureOfString().as(c.future);
  };
  dart.fn(lib__src__webhelper__lib.LoadJson, StringToFutureOfString());
  lib__src__webhelper__lib.LoadImage = function(url) {
    let c = async.Completer.new();
    let image = html.ImageElement.new();
    image[dartx.onLoad].first.then(dart.void)(dart.fn(_ => c.complete(image), EventTovoid()));
    image.src = url;
    return FutureOfImageElement().as(c.future);
  };
  dart.fn(lib__src__webhelper__lib.LoadImage, StringToFutureOfImageElement());
  lib__src__webhelper__lib.LoadVideo = function(url) {
    let c = async.Completer.new();
    let video = html.VideoElement.new();
    video.autoplay = true;
    video.loop = true;
    video[dartx.onPlaying].first.then(dart.void)(dart.fn(_ => c.complete(video), EventTovoid()));
    video.src = url;
    return FutureOfVideoElement().as(c.future);
  };
  dart.fn(lib__src__webhelper__lib.LoadVideo, StringToFutureOfVideoElement());
  dart.defineLazy(lib__src__webhelper__lib, {
    get _kUrlInfix() {
      return JSArrayOfString().of(["nx", "px", "ny", "py", "nz", "pz"]);
    }
  });
  lib__src__webhelper__lib.LoadCubeImages = function(urlPrefix, urlSuffix) {
    let out = ListOfFutureOfImageElement().new(6);
    for (let i = 0; i < dart.notNull(lib__src__webhelper__lib._kUrlInfix[dartx.length]); ++i) {
      let c = async.Completer.new();
      let image = html.ImageElement.new();
      image[dartx.onLoad].first.then(dart.void)(dart.fn(_ => c.complete(image), EventTovoid()));
      image.src = dart.notNull(urlPrefix) + dart.notNull(lib__src__webhelper__lib._kUrlInfix[dartx._get](i)) + dart.notNull(urlSuffix);
      out[dartx._set](i, FutureOfImageElement().as(c.future));
    }
    return out;
  };
  dart.fn(lib__src__webhelper__lib.LoadCubeImages, StringAndStringToListOfFutureOfImageElement());
  lib__src__webhelper__lib.MakeVideoElementFromCamera = function() {
    let c = async.Completer.new();
    html.window.navigator[dartx.getUserMedia]({video: true}).then(core.Null)(dart.fn(stream => {
      let video = html.VideoElement.new();
      video.autoplay = true;
      video[dartx.onPlaying].first.then(dart.void)(dart.fn(_ => c.complete(video), EventTovoid()));
      video.src = html.Url.createObjectUrl(stream);
    }, MediaStreamToNull())).catchError(dart.fn(error => {
      c.complete(null);
    }, dynamicToNull()));
    return FutureOfVideoElement().as(c.future);
  };
  dart.fn(lib__src__webhelper__lib.MakeVideoElementFromCamera, VoidToFutureOfVideoElement());
  lib__src__webhelper__lib.MakeSolidColorCanvas = function(fillStyle) {
    let canvas = html.CanvasElement.new({width: 2, height: 2});
    let ctx = html.CanvasRenderingContext2D._check(canvas[dartx.getContext]('2d'));
    ctx.fillStyle = fillStyle;
    ctx.fillRect(0, 0, canvas.width, canvas.height);
    return canvas;
  };
  dart.fn(lib__src__webhelper__lib.MakeSolidColorCanvas, StringToCanvasElement());
  lib__src__webhelper__lib.MakeSolidColorTexture = function(cgl, url, fillStyle) {
    return new lib__src__core__lib.ImageTexture(cgl, url, lib__src__webhelper__lib.MakeSolidColorCanvas(fillStyle));
  };
  dart.fn(lib__src__webhelper__lib.MakeSolidColorTexture, ChronosGLAndStringAndStringToTexture());
  lib__src__webhelper__lib.MakeSolidColorTextureRGB = function(cgl, url, rgb) {
    let r = (255.0 * dart.notNull(rgb.r))[dartx.round]();
    let g = (255.0 * dart.notNull(rgb.g))[dartx.round]();
    let b = (255.0 * dart.notNull(rgb.b))[dartx.round]();
    return new lib__src__core__lib.ImageTexture(cgl, url, lib__src__webhelper__lib.MakeSolidColorCanvas(dart.str`rgb(${r}, ${g}, ${b})`));
  };
  dart.fn(lib__src__webhelper__lib.MakeSolidColorTextureRGB, ChronosGLAndStringAndVector3ToTexture());
  lib__src__webhelper__lib.MakeSolidColorTextureRGBA = function(cgl, url, rgba) {
    let r = (255.0 * dart.notNull(rgba.r))[dartx.round]();
    let g = (255.0 * dart.notNull(rgba.g))[dartx.round]();
    let b = (255.0 * dart.notNull(rgba.b))[dartx.round]();
    return new lib__src__core__lib.ImageTexture(cgl, url, lib__src__webhelper__lib.MakeSolidColorCanvas(dart.str`rgba(${r}, ${g}, ${b}, ${rgba.a})`));
  };
  dart.fn(lib__src__webhelper__lib.MakeSolidColorTextureRGBA, ChronosGLAndStringAndVector4ToTexture());
  dart.trackLibraries("lib_webhelper", {"lib/src/webhelper/lib.dart": lib__src__webhelper__lib}, null);
  // Exports:
  exports.lib__src__webhelper__lib = lib__src__webhelper__lib;
}));
